package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import java.util.*;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3Field;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;

public class CSDelegate {
	private SortableTreeNode topNode = null;
   
   private CodingSchemaService service;

	public CSDelegate(SS3CodingScheme codingScheme, CodingSchemaService service) {
      this.service = service;
      
		topNode = new SortableTreeNode(codingScheme);
		init(codingScheme);
	}

	private void init(SS3CodingScheme codingScheme) {
      ArrayList list = service.sortByFiedName(codingScheme.getFields().values());
      
		Iterator iterator = list.iterator();

		while (iterator.hasNext()) {
         SS3Field field = (SS3Field)iterator.next();

			if (field != null)
				addSS3Field(field);
		}
	}

	public void addSS3Field(SS3Field field) {
		SortableTreeNode fieldNode = new SortableTreeNode(field);
		topNode.add(fieldNode);

      ArrayList list = service.sortByValueName(field.getValuesAsList());
      
      Iterator iterator = list.iterator();
      while(iterator.hasNext()) {
         SS3FieldValue value = (SS3FieldValue) iterator.next();
         addSS3FieldValue(value, fieldNode); 
      }

	}

	public boolean removeSS3Field(SS3Field field) {
		SortableTreeNode fieldNode = getSortableTreeNodeRepresentation(field);
		if (fieldNode != null) {
			topNode.remove(fieldNode);
			return true;
		}
		return false;
	}
	
	public boolean addSS3FieldValue(SS3FieldValue value, SS3Field field) {
		SortableTreeNode fieldNode = getSortableTreeNodeRepresentation(field);
		if (fieldNode != null) {
			addSS3FieldValue(value, fieldNode);
			return true;
		}
		return false;
	}

	public SortableTreeNode getSortableTreeNodeRepresentation(
			SS3Field field) {
      
		Enumeration en = topNode.children();
		while (en.hasMoreElements()) {
			Object obj = en.nextElement();
			SortableTreeNode fieldNode = (SortableTreeNode) obj;
			Object userObj = fieldNode.getUserObject();
			if (userObj instanceof SS3Field) {
				SS3Field fld = (SS3Field) userObj;
				if (field.getName().equalsIgnoreCase(fld.getName())) {
					return fieldNode;
				}
			}
		}
      
		return null;
	}

	public void addSS3FieldValue(SS3FieldValue value, SortableTreeNode fieldNode) {
		SortableTreeNode valueNode = new SortableTreeNode(value);
		fieldNode.add(valueNode);
      // fieldNode.sort();
	}

	public boolean removeSS3FieldValue(SS3FieldValue fieldValue, SS3Field field) {
		SortableTreeNode fieldNode = getSortableTreeNodeRepresentation(field);
		if (fieldNode != null) {
			Enumeration chEn = fieldNode.children();
			while (chEn.hasMoreElements()) {
				Object chObj = chEn.nextElement();
				SortableTreeNode valueNode = (SortableTreeNode) chObj;
				Object userChObj = valueNode.getUserObject();

				if (userChObj instanceof SS3FieldValue) {
					SS3FieldValue value = (SS3FieldValue) userChObj;
					if (value.getName().equalsIgnoreCase(fieldValue.getName())) {
						fieldNode.remove(valueNode);
						return true;
					}
				}
			}
		}
		return false;
	}
   
   

	public SortableTreeNode getSortableTreeNode() {
      //
      //sort!!!
      //
		return topNode;
	}
}
