/*
 * Created on Aug 2, 2007
 */
package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3Field;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class ComparedCodingSchemaPanel extends JPanel {

   private String defLegacyFileLocation = null;

   private SortableEntitiesPanel vPanel;
   
   private JDialog parentDialog;

   public ComparedCodingSchemaPanel(LegacyCodingSchemaFormBean formBean, JDialog parentDialog) {
      this.parentDialog = parentDialog;
      JPanel panel = initUI(formBean);
      setLayout(new BorderLayout());
      add(panel, BorderLayout.CENTER);
   }

   private JPanel initUI(LegacyCodingSchemaFormBean formBean) {

      JPanel panel = new JPanel();

      Object[] mColumnNames =
         { "id", "Field Name", "Field Label", "Field Type" };

      SS3CodingScheme schema =
         SS3Singleton.getSS3CodingSchemeCollection().getDefaultCodingScheme();

      Collection mFields = schema.getFields().values();

      Object[][] data = new Object[mFields.size()][];

      Iterator mIter = mFields.iterator();
      int j = 0;
      while (mIter.hasNext()) {
         SS3Field mField = (SS3Field) mIter.next();
         Object[] values =
            {
               mField.getId(),
               mField.getName(),
               mField.getLabel(),
               mField.getType()};
         data[j] = values;
         j++;
      }

      SortableEntitiesPanel mPanel = new SortableEntitiesPanel(mColumnNames, data);
      mPanel.setMasterCodingSchema(schema);
      mPanel.setDialog(parentDialog);
      mPanel.setBorder(new TitledBorder("Master Coding Schema"));

      Object[] vColumnNames =
         {
            "",
            "Field Name",
            "Field Label",
            "Difference found",
            "Field not found in Master Schema" };

      ArrayList entities = formBean.getEntities();
      Object[][] vData = new Object[entities.size()][];

      for (int i = 0; i < entities.size(); i++) {
         LegacyCodingSchemaEntity entity =
            (LegacyCodingSchemaEntity) entities.get(i);
         Object[] values =
            {
               entity.getId(),
               entity.getName(),
               entity.getLabel(),
               entity.getDiffEntityMarker(),
               entity.getNotFoundInMasterSchemaMarker()};
         vData[i] = values;
      }

      vPanel = new SortableEntitiesPanel(vColumnNames, vData);
      vPanel.setLegacyCodingSchemaFormBean(formBean);
      vPanel.setDialog(parentDialog);
      vPanel.setBorder(new TitledBorder("Compared Legacy Coding Schema"));

      SortableTableModel model = vPanel.getSortableTableModel();

      JPanel lPanel = new JPanel();
      lPanel.setLayout(new BorderLayout());

      GridLayout gLayout = new GridLayout(0, 2);
      panel.setLayout(gLayout);
      panel.add(vPanel);
      panel.add(mPanel);

      return panel;
   }

}
