package edu.bu.signstream.common.filesLocators;

import java.io.File;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class MediaFilesLocator {
	// String of paths where video files are located
	private Set paths = new HashSet();
   
	
	// directory where located last loaded video file
	private String lastLoadedDirectory = "";
	
	public MediaFilesLocator() {
   }
	
	public String getLastLoadedDirectory() {
		return lastLoadedDirectory;
	}
	
	public void setLastLoadedDirectory(String lastLoadedDirectory) {
		this.lastLoadedDirectory = lastLoadedDirectory;
	}
	
	public void addLocation(String path) {
		paths.add(path);
	}
	
	public Set getLocations() {
		return paths;
	}
	
	public File locateMediaFile(String fileName) {
		File file = new File(fileName);
		if(file.exists()) {
			lastLoadedDirectory = file.getParentFile().getPath();
			return file;
		}
		
		String dv = SS3Singleton.getFilesLocation().getFileSeparator();
		Iterator it = paths.iterator();
		while(it.hasNext()) {
			String path = (String)it.next();
			String fPath = path + dv + fileName;
			File nfile = new File(fPath);
			if(nfile.exists()) {
				lastLoadedDirectory = nfile.getParentFile().getPath();
				return nfile;
			}
		}	
		return file;
	}	
}
