package edu.bu.signstream.common.util.vo;

import java.util.ArrayList;

public class Constants {
	public static final int HOLD_CODE = 400000;
	//public static final int INITIAL_HOLD_CODE = 400004;
	//public static final int FINAL_HOLD_CODE = 400005;
	public static final int ONSET_CODE = 400001;
	public static final int OFFSET_CODE = 400002;
	public static final int EMPTY_CODE = 400003;

	public static final String HOLD_VAL = "HOLD";
	public static final String ONSET_VAL = "ONSET";
	public static final String OFFSET_VAL = "OFFSET";
	public static final String EMPTY_VAL = "EMPTY";

	public static final String ONSET = "Onset";
	public static final String INITIAL_HOLD = "Initial Hold";
	public static final String OFFSET = "Offset";
	public static final String FINAL_HOLD = "Final Hold";
	public static final String VALUE = "Value";
	public static final String TEXT_VALUE = "Text Value";
	
	

	public static ArrayList<String> getReservedCodingSchemaCodes() {
		ArrayList<String> list = new ArrayList<String>();
		list.add("" + Constants.HOLD_CODE);
		list.add("" + Constants.ONSET_CODE);
		list.add("" + Constants.OFFSET_CODE);
		list.add("" + Constants.EMPTY_CODE);
		return list;
	}

	private static ArrayList<String> textEntryIdList = null;

	public static ArrayList<String> getTestEntryIdList() {
		if (textEntryIdList == null) {
			textEntryIdList = new ArrayList<String>();
			textEntryIdList.add("31");
			textEntryIdList.add("42");
			textEntryIdList.add("10000");
			textEntryIdList.add("10001");
			textEntryIdList.add("20000");
			textEntryIdList.add("20001");
		}
		return textEntryIdList;
	}

	public static final String SIGNATURE = "sASL";
	public static final int RECENT_FILE_VERSION = 31;
	public static final int CURRENT_FILE_VERSION = 32;

	// see "asl utterance scrap.h"
	public static final int UTT_CURR_SCRAP_FORMAT_VERSION = 14;

	// see "asl MD scrap.h"
	public static final int MD_CURR_SCRAP_FORMAT_VERSION = 1;

	// see "asl MediaRef scrap.h"
	public static final int MREF_CURR_SCRAP_FORMAT_VERSION = 1;

	// see "asl field scrap.h":
	public static final int FIELD_CURR_SCRAP_FORMAT_VERSION = 5;

	// see "asl non-manual data scrap.h":
	public static final int NON_MANUAL_DATA_CURR_SCRAP_FORMAT_VERSION = 4;

	// see "asl gloss data scrap.h":
	public static final int GLOSS_CURR_SCRAP_FORMAT_VERSION = 3;

	public static final String TYPE_NON_MANUAL_OLD = "0";
	public static final String TYPE_GLOSS_OLD = "1";
	public static final String TYPE_POS_TAG_OLD = "2"; // unused in SS2
	public static final String TYPE_FREE_TEXT_OLD = "3";
	public static final String TYPE_HAND_SHAPE_OLD = "4";

	public static final String TYPE_NON_MANUAL = "NMN";
	public static final String TYPE_GLOSS = "GLS";
	//public static final String TYPE_POS_TAG = "POS"; // unused in SS2
	// ----------------- //
	public static final String TYPE_GLOSS_LEGACY = "LGLS";
	public static final String TYPE_DOM_GLOSS = "DGLS";
	public static final String TYPE_NON_DOM_GLOSS = "NGLS";
	public static final String TYPE_DOM_POS_TAG = "DPOS"; // unused in SS2
	public static final String TYPE_NON_DOM_POS_TAG = "NPOS"; // unused in SS2
	public static final String TYPE_RIGHT_HAND_SHAPE = "RHSH"; // unused in SS2
	public static final String TYPE_LEFT_HAND_SHAPE = "LHSH"; // unused in SS2
	public static final String TYPE_DOM_TEXT = "DTXT";
	public static final String TYPE_NON_DOM_TEXT = "NTXT";
	//public static final String TYPE_FNGR_SPELLING = "FSPL";
	
	public static final String TYPE_RIGHT_HAND_LOCATION = "RHSL";
	public static final String TYPE_LEFT_HAND_LOCATION = "LHSL";
	public static final String TYPE_RIGHT_HAND_MOVEMENT = "RHSM";
	public static final String TYPE_LEFT_HAND_MOVEMENT = "LHSM";
	public static final String TYPE_RIGHT_HAND_ORIENTATION = "RHSO";
	public static final String TYPE_LEFT_HAND_ORIENTATION = "LHSO";
   public static final String TYPE_RIGHT_HAND_SEL_FINGERS = "RHSSF";
   public static final String TYPE_LEFT_HAND_SEL_FINGERS = "LHSSF";
   public static final String TYPE_RIGHT_HAND_BASE_JOINTS = "RHSBJ";
   public static final String TYPE_LEFT_HAND_BASE_JOINTS = "LHSBJ";
   public static final String TYPE_RIGHT_HAND_SPREAD = "RHSSP";
   public static final String TYPE_LEFT_HAND_SPREAD = "LHSSP";
   public static final String TYPE_RIGHT_HAND_NON_BASE_JOINTS = "RHSNJ";
   public static final String TYPE_LEFT_HAND_NON_BASE_JOINTS = "LHSNJ";
   public static final String TYPE_RIGHT_HAND_NON_SEL_FINGERS = "RHSNF";
   public static final String TYPE_LEFT_HAND_NON_SEL_FINGERS = "LHSNF";
   public static final String TYPE_RIGHT_HAND_THUMB_CONTACT = "RHSTC";
   public static final String TYPE_LEFT_HAND_THUMB_CONTACT = "LHSTC";
	
   public static final String TYPE_HAND = "HND";
   public static final String TYPE_RIGHT_HAND = "RHND";
	public static final String TYPE_LEFT_HAND = "LHND";
		
	public static final String TYPE_FREE_TEXT = "FRT";
	//public static final String TYPE_HAND_SHAPE = "HSH";
	
	//public static final String RIGHT = "RIGHT";
	//public static final String LEFT = "LEFT";
	
	public static final String RIGHT_HAND = "R";
	public static final String LEFT_HAND = "L";
	
	public static final String DOMINANT = "dom";
	public static final String NON_DOMINANT = "ndom";
	
	public static final String VC_BODY_LOCATION = "1";
	public static final String VC_PROXIMITY = "2";
	public static final String VC_LATERALIZATION = "3";
	public static final String VC_DIRECTIONAL_MOVEMENT = "4";
	public static final String VC_MOVEMENT_CONTOUR = "5";
	public static final String VC_REPETITION = "6";
	public static final String VC_COORDINATION = "7";
	public static final String VC_MANER_OF_TOUCH = "8";
	
	// --------------------- //
	public static final String TYPE_HOLD = "400000";
	public static final String TYPE_ONSET = "400001";
	public static final String TYPE_OFFSET = "400002";
	public static final String TYPE_EMPTY = "400003";
	// --------------------- //

	public static final int GROUP_UPPER = 0;
	public static final int GROUP_FIXED = 1;
	public static final int GROUP_LOWER = 2;

	// ID offsets, since each group starts fields at zero in DB files
	public static final int GROUP_FIXED_ID_OFFSET = 10000;
	public static final int GROUP_LOWER_ID_OFFSET = 20000;
}
