package edu.bu.signstream.common.util.vo;

import java.util.ArrayList;

public class Excerpt {
   // excerpt id == utterance id
   private String id, excerpt, path;
   // list of corresponding media file IDs (media files are stored in SS3Database)
   private ArrayList<Object> mediaFiles = new ArrayList<Object>();
   private boolean selected = false;

   public Excerpt(String id, String excerpt) {
      this.id = id;
      this.excerpt = excerpt;
   }

   public void addOrOverrideMediaFileID(String id) {
      for (int i = 0; i < mediaFiles.size(); i++) {
          String lID = (String) mediaFiles.get(i);

         if (lID.equalsIgnoreCase(id))
            return;
      }
      mediaFiles.add(id);
   }

   public void setSelected(boolean selected) {
      this.selected = selected;
   }

   public boolean isSelected() {
      return selected;
   }

   @Override
public String toString() {
      StringBuffer sb = new StringBuffer();
      sb.append(id);
      sb.append("   ");
      sb.append(excerpt);
      return sb.toString();
   }

   public String getID() {
      return id;
   }

   public String getExcerpt() {
      return excerpt;
   }
   
   public void setExcerpt(String excerpt) {
      this.excerpt = excerpt;
   }

   public String getPath() {
      return path;
   }

   public void setPath(String path) {
      this.path = path;
   }

   public ArrayList<Object> getMediaFiles() {
      return mediaFiles;
   }

   public void setMediaFiles(ArrayList list) {
      mediaFiles = list;
   }
}
