package edu.bu.signstream.common.util.vo;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Database;

import java.util.*;

public class SignStreamDocument {
	private Profile profile;
	private HashMap participants = null;
	private HashMap codingScheme = null;
	private HashMap mediaFiles = null; 
	private HashMap utterances = null; 
	private ArrayList<Excerpt> excerpts = null;
   private String fileName = null;

	public SignStreamDocument(
		Profile profile,
		HashMap participants,
		HashMap codingScheme,
		HashMap mediaFiles,
		HashMap utterances, 
      String fileName) {
		this.profile = profile;
		this.participants = participants;
		this.codingScheme = codingScheme;
		this.mediaFiles = mediaFiles;
		this.utterances = utterances;
      this.fileName = fileName;	
	}
   
   public String getFileName() {
      return fileName;
   }

	public HashMap getCodingScheme() {
		return codingScheme;
	}

	public Profile getProfile() {
		return profile;
	}

	public HashMap getMediaFiles() {
		return mediaFiles;
	}

	public HashMap getParticipants() {
		return participants;
	}

	public Participant getParticipant(String participantID) {
		return (Participant) participants.get(participantID);
	}

	public HashMap getUtterances() {
		return utterances;
	}
	
	public MediaFile getMediaFile(String id) {
		return (MediaFile) mediaFiles.get(id);
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("" + profile);
		sb.append("\n \n participants.size() = " + participants.size());
		sb.append("\n codingScheme.size() = " + codingScheme.size());
		sb.append("\n mediaFiles.size() = " + mediaFiles.size());
		sb.append("\n utterances.size() = " + utterances.size());
		return sb.toString();
	}

	public Utterance getUtterance(String key) {
		return (Utterance) utterances.get(key);
	}

	public ArrayList<Excerpt> getExcerpts() {

		if (excerpts == null) {
			excerpts = new ArrayList<Excerpt>();

			for (int i = 0; i < utterances.size(); i++) {
				Utterance utter = getUtterance("" + i);
				String id = utter.getId();
				String strExcerpt = utter.getExcerpt();
				Excerpt excerpt = new Excerpt(id, strExcerpt);
				excerpts.add(excerpt);
            
            // list of MediaFile objects
            ArrayList mediaFiles = utter.getMediaFilesAsCollection();
            ArrayList list = new ArrayList();
            for(int j = 0; j < mediaFiles.size(); j++) {
               MediaFile mf = (MediaFile)mediaFiles.get(j);
               list.add(mf.getId());
            }
            excerpt.setMediaFiles(list);
			}
		}
		return excerpts;
	}

//    public ArrayList<SS3Database> getSS3Databases() {
//        ArrayList<SS3Database> databases = new ArrayList<SS3Database>();
//        // HashMap utterances =
//        Set keys = utterances.keySet();
//        Iterator iter = keys.iterator();
//    }
}
