package edu.bu.signstream.common.util.vo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;

public class Utterance {
	private String id, excerpt;
	private TimeInfo startTimeInfo, endTimeInfo;
	private HashMap mediaFiles = new HashMap();
	private HashMap participants = new HashMap();
	private ArrayList segments = new ArrayList();
	private ArrayList notes = new ArrayList();

	public Utterance() {
	}

	public Utterance(
		String id,
      TimeInfo startTimeInfo,
      TimeInfo endTimeInfo,
		String excerpt,
		HashMap mediaFiles,
		HashMap participants,
		ArrayList segments,
		ArrayList notes) {
		this.id = id;
		this.startTimeInfo = startTimeInfo;
		this.endTimeInfo = endTimeInfo;
		this.excerpt = excerpt;
		this.mediaFiles = mediaFiles;
		this.participants = participants;
		this.segments = segments;
		this.notes = notes;
	}

	public TimeInfo getEndTimeInfo() {
		return endTimeInfo;
	}

	public void setEndTimeInfo(TimeInfo endTimeInfo) {
		this.endTimeInfo = endTimeInfo;
	}

	public ArrayList getNotes() {
		return notes;
	}

	public void setNotes(ArrayList notes) {
		this.notes = notes;
	}

	public String getExcerpt() {
		return excerpt;
	}

	public void setExcerpt(String excerpt) {
		this.excerpt = excerpt;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public HashMap getMediaFiles() {
		return mediaFiles;
	}

	public void setMediaFiles(HashMap mediaFiles) {
		this.mediaFiles = mediaFiles;
	}

	public void setParticipants(HashMap participants) {
		this.participants = participants;
	}
	
	public HashMap getParticipants() {
		return participants;
	}

	public ArrayList getSegments() {
		return segments;
	}

	public void setSegments(ArrayList segments) {
		this.segments = segments;
	}

	public TimeInfo getStartTimeInfo() {
		return startTimeInfo;
	}

	public void setStartTimeInfo(TimeInfo startTimeInfo) {
		this.startTimeInfo = startTimeInfo;
	}

	public Segment getSegment(int segmentID) {
		return (Segment) segments.get(segmentID);
	}

	public ArrayList getMediaFilesAsCollection() {
		ArrayList list = new ArrayList();
		Set kSet = mediaFiles.keySet();
		Iterator kIt = kSet.iterator();

		while (kIt.hasNext()) {
			String key = (String) kIt.next();
			Object obj = mediaFiles.get(key);
			list.add(obj);
		}
		return list;
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("Utterance:");
		sb.append("\n id = ");
		sb.append(id);
		sb.append("\n excerpt = ");
		sb.append(excerpt);
		sb.append("\n notes = ");
		sb.append(notes);
//		sb.append("\n start = ");
//		sb.append(start);
//		sb.append("\n end = ");
//		sb.append(end);
		sb.append("\n number of media files = ");
		sb.append(mediaFiles.size());
		sb.append("\n mediaFiles = ");

		Set mSet = mediaFiles.entrySet();
		Iterator mIt = mSet.iterator();

		sb.append("\n number of participants = ");
		sb.append(participants.size());
		sb.append("\n participants = ");

		Set pSet = participants.entrySet();
		Iterator pIt = pSet.iterator();
		while (pIt.hasNext()) {
			Participant prts = (Participant) pIt.next();
			sb.append(prts.toString());
		}

		sb.append("\n number of segments = ");
		sb.append(segments.size());
		sb.append("\n segments = ");

		return sb.toString();
	}
}
