package edu.bu.signstream.common.util.vo.ss3.codingScheme.handShapes;

import java.util.ArrayList;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;

public class CSHandShapePalette {

   private String id;
   private String templateId;
   private String name;

  // use array list because we should preserve the order of the icons 
   private ArrayList<CSHandShapeItem> handShapeItems = new ArrayList<CSHandShapeItem>();

   public void addHandShapeItem(CSHandShapeItem item) {
      handShapeItems.add(item);
   }
   
   public CSHandShapeItem getHandShapeItems(String id) {
	   for(CSHandShapeItem item:handShapeItems) {
		   if(id.equalsIgnoreCase(item.getId())) {
			   return item;
		   }
	   }
	   return null;
   }

   public ArrayList<CSHandShapeItem> getHandShapeItems() {
      return handShapeItems;
   }

   public String getId() {
      return id;
   }

   public String getName() {
      return name;
   }

   public void setHandShapeItems(ArrayList<CSHandShapeItem> list) {
      this.handShapeItems = list;
   }

   public void setId(String string) {
      id = string;
   }

   public void setName(String string) {
      name = string;
   }

   public String getTemplateIdId() {
      return templateId;
   }

   public void setTemplateId(String string) {
      templateId = string;
   }
   
   /*
    * returns templateId + | + id
    * */
   public String getCombinedId() {
      return templateId + "|" + id;
   }
   
   // returns a list of SS3FieldValue objects
   public ArrayList<SS3FieldValue> getImmageItems(SS3CodingScheme cSheme, String fieldType) {       
      return cSheme.getCorrespondingFieldValues(handShapeItems, fieldType);
   }
   
   @Override
public String toString() {
      String lbl = getName().length() < 18 ? getName() : getName().substring(0, 18)+"...";
      return lbl;
   } 
}
