package edu.bu.signstream.common.util.vo.ss3.db;

import java.awt.Color;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.common.util.vo.TrackValue;

public class SS3Item {
	private String id = "";
	private String imageID = "";
	private String text = "";
	private String noteID = "";

	private TimeInfo startTimeInfo = new TimeInfo();
	private TimeInfo endTimeInfo = new TimeInfo();

	private boolean startTimeFinal = false;
	private boolean endTimeFinal = false;
	private boolean textOnly = false;

	private String startCompaundEntityID = "";
	private String endCompaundEntityID = "";

	private Color color;

	public SS3Item() {
	}

	public SS3Item(String text, TimeInfo startTimeInfo) {
		this.text = text;
		this.startTimeInfo = startTimeInfo;
	}
	
	public SS3Item(String id, String imageID, TimeInfo startTimeInfo, TimeInfo endTimeInfo) {
		this.id = id;
		this.imageID = imageID;
		setStartTimeInfo(startTimeInfo.cloneTimeInfo());
		setEndTimeInfo(endTimeInfo.cloneTimeInfo());
	}
	
	public void setTextOnly(boolean textOnly) {
		this.textOnly = textOnly;
	}
	
	public boolean isTextOnly() {
		return textOnly;
	}

	public SS3Item(TrackValue value) {
		setId("" + value.getValueId());
		setStartTimeInfo(value.getStartTimeInfo());
		setEndTimeInfo(value.getEndTimeInfo());
		setText(value.getTextValue());
		this.startTimeInfo = value.getStartTimeInfo();
		this.endTimeInfo = value.getEndTimeInfo();
	}

	public String getStartCompaundEntityID() {
		return startCompaundEntityID;
	}

	public void setStartCompaundEntityID(String startCompaundEntityID) {
		this.startCompaundEntityID = startCompaundEntityID;
	}

	public String getEndCompaundEntityID() {
		return endCompaundEntityID;
	}

	public void setEndCompaundEntityID(String endCompaundEntityID) {
		this.endCompaundEntityID = endCompaundEntityID;
	}

	public void setImageID(String imageID) {
		this.imageID = imageID;
	}

	public String getImageID() {
		return imageID;
	}

	public String getNoteID() {
		return noteID;
	}

	public void setNoteID(String noteID) {
		this.noteID = noteID;
	}

	public String getId() {
		if (id == null || id.length() == 0)
			id = "" + Util.getUniqueNumber();
		return id;
	}

	public String getText() {
		return text;
	}

	public void setId(String string) {
		id = string;
	}

	public void setText(String string) {
		text = string;
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer("SS3Item: \n");
		sb.append("id = " + id);
		sb.append(", text = " + text);
		sb.append(", startTime = " + startTimeInfo.getMovieTime());
		sb.append(", endTime = " + endTimeInfo.getMovieTime());
		return sb.toString();
	}

	public Color getColor() {
		return color;
	}

	public void setColor(Color color) {
		this.color = color;
	}

	public TimeInfo getEndTimeInfo() {
		return endTimeInfo;
	}

	public TimeInfo getStartTimeInfo() {
		return startTimeInfo;
	}

	public void setEndTimeInfo(TimeInfo info) {
		endTimeInfo = info;
	}

	public void setStartTimeInfo(TimeInfo info) {
		startTimeInfo = info;
	}

	public boolean isEndTimeFinal() {
		return endTimeFinal;
	}

	public boolean isStartTimeFinal() {
		return startTimeFinal;
	}

	public void setEndTimeFinal(boolean b) {
		endTimeFinal = b;
	}

	public void setStartTimeFinal(boolean b) {
		startTimeFinal = b;
	}
}
