package edu.bu.signstream.common.util.vo.ss3.media;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import edu.bu.signstream.common.util.vo.ss3.db.SS3DBProfile;
import edu.bu.signstream.ui.SerchableDirectory;

public class SS3MediaLibrary {
   
   private String defFileLocation;
   
   // contains files
   private ArrayList<SerchableDirectory> directoriesToSearch = new ArrayList<SerchableDirectory>();

   // key ==> id
   private HashMap<String, SS3MediaFile> library = new HashMap<String, SS3MediaFile>();
   
   private SS3DBProfile profile = new SS3DBProfile();

   private String fileName = "";
   
   public SS3MediaLibrary(String fileName) {
	   this.fileName = fileName;
   }
   
   public String getFileName() {
	   return fileName;
   }
   
   public void addMediaFile(SS3MediaFile file) {
      library.put(file.getId(), file);
   }
   
   public void addDirectoryToSearch(SerchableDirectory directory) {
	   directoriesToSearch.add(directory);
   }
   
   public ArrayList<SerchableDirectory> getDirectoriesToSearch() {
      return directoriesToSearch;
   } 

   public SS3MediaFile getMediaFile(String id) {
      return library.get(id);
   }

   public Collection<SS3MediaFile> getMediaFilesList() {
      return library.values();
   }
 
   public String getDefFileLocation() {
      return defFileLocation;
   }

   public void setDefFileLocation(String string) {
      defFileLocation = string;
   }


   public HashMap<String, SS3MediaFile> getLibrary() {
      return library;
   }

   public SS3DBProfile getProfile() {
      return profile;
   }
}
