package edu.bu.signstream.grepresentation.fields;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.util.ArrayList;

import javax.swing.JPanel;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public abstract class EventsEntity extends JPanel implements Event {

	private static final long serialVersionUID = 1L;

	protected boolean selected = false;

	private boolean highlighted = false;

	private String id = "";

	private String refEntityId = "";

	//protected String fieldID = "";

	private Color color = null;
   
	private Field field;

	private PresentationEventsEntity parentEntity = null;

//	private String uniqueID = "";

	protected SignStreamSegmentPanel segmentPanel = null;
   
//   private int beforeCompoundID = -1;
//   private int afterCompoundID = -1;
   
//	public static final int ONSET = 0;
//	public static final int INITIAL_HOLD = 1;
//	public static final int FINAL_HOLD = 2;
//	public static final int OFFSET = 3;

	public EventsEntity(SignStreamSegmentPanel segmentPanel, Field field) {
		//this.fieldID = fieldID;
		this.field = field;
		this.segmentPanel = segmentPanel;
	}
	
//	@Override
//	public String getUniqueID() {
//		return uniqueID;
//	}
//	
//	@Override
//	public void setUniqueID(String uniqueID) {
//		this.uniqueID = uniqueID;
//	}

	public SignStreamSegmentPanel getSignStreamSegmentPanel() {
		return segmentPanel;
	}

//	public void setFieldID(String fieldID) {
//		this.fieldID = fieldID;
//	}
//
//	public String getFieldID() {
//		return fieldID;
//	}

	// implement for every field type!!!
	public abstract SS3Entity getSS3Entity();  
//	{
//		SS3Entity entity = new SS3Entity();
//      //String entID = id.trim().length() > 0 ? id : Util.getLongUniqueNumber();       
//		entity.setID(id);
//		entity.setRefEntityId(refEntityId);
//		entity.setReference(ref);
//		
//      entity.setValueStartTimeLocked(isValueStartTimeLocked());
//      entity.setValueEndTimeLocked(isValueEndTimeLocked());
//      entity.setInitialHoldStartTimeLocked(isInitialHoldStartTimeLocked());
//      entity.setFinalHoldEndTimeLocked(isFinalHoldEndTimeLocked());
//
//		return entity;
//	}

	@Override
	public void setColor(Color color) {
		this.color = color;
	}

	@Override
	public Color getColor() {
		return color;
	}

//	public void setShowNote(boolean showNote) {
//		this.showNote = showNote;
//	}
//
//	public boolean isShowNote() {
//		return showNote;
//	}

	@Override
	public void setID(String id) {
		this.id = id;
	}

	@Override
	public String getID() {
		return id;
	}

	public void setRefEntityId(String refEntityId) {
		this.refEntityId = refEntityId;
	}

	public String getRefEntityId() {
		return refEntityId;
	}

	public abstract Event getFirstEvent();

	public abstract Event getLastEvent();

	@Override
	public boolean isSelected() {
		return selected;
	}

	public void highlight(boolean highlight) {
		this.highlighted = highlight;
	}

	@Override
	public boolean isHighlighted() {
		return highlighted;
	}

	@Override
	public int getStartTimeCoordinate() {
		
		//getStartTimeInfo().getMovieTime();
		
		
		return segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertTimeToCoordinate(getStartTimeInfo().getMovieTime());
	}

	@Override
	public int getEndTimeCoordinate() {
		return segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertTimeToCoordinate(getEndTimeInfo().getMovieTime());
	}

	@Override
	public void setStartTimeCoordinate(int coord) {
		int time = segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertCoordinateToTime(coord);
		getStartTimeInfo().setMovieTime(time);
	}

	@Override
	public void setEndTimeCoordinate(int coord) {
		int time = segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertCoordinateToTime(coord);
		getEndTimeInfo().setMovieTime(time);
	}

	public boolean contains(int x) {
		try {
		int startCoord = getStartTimeCoordinate();
		int endCoord = getEndTimeCoordinate();
		
		if(getStartTimeInfo().getMovieTime() == getEndTimeInfo().getMovieTime()) {
			startCoord = startCoord - 5;
			endCoord = endCoord + 5;
		}
		
		if(startCoord > endCoord) {
			int startTime = getStartTimeInfo().getMovieTime();
			int endTime = getEndTimeInfo().getMovieTime();
			getStartTimeInfo().setMovieTime(endTime);
			getEndTimeInfo().setMovieTime(startTime);
			
			return (endCoord <= x && x <= startCoord);
		} else {		
			return (startCoord <= x && x <= endCoord);
		}
		} catch(Exception ex) {
			return false;
		}
	}

	public boolean isEntityInsideElement(int x1, int x2) {
		return (x1 < getStartTimeCoordinate() && x2 > getEndTimeCoordinate());
	}

	public boolean isOverlapping(int coordx1, int coordx2) {
		int startCoord = getStartTimeCoordinate();
		int endCoord = getEndTimeCoordinate();

		return (coordx1 <= startCoord && coordx2 >= startCoord)
				|| (coordx1 <= endCoord && coordx2 >= endCoord);
	}

	public abstract boolean selectEntityIfEventSelected();

	public abstract boolean selectEventIfEntitySelected();

	@Override
	public abstract boolean select();

	@Override
	public abstract boolean unselect();

	public abstract boolean adjustEntity(int x1, int x2);

	public abstract Event getSelectedEvent();

	public abstract void reset();

	public abstract boolean delete();

	public abstract Event getEventAt(int x);

	public abstract ArrayList<String> getEventsToAdd();

	public abstract String getToolTipText(int x);

	// public abstract boolean setSelectedEventStartCoordinate(int coord);
	// public abstract boolean setSelectedEventEndCoordinate(int coord);

	public abstract boolean selectEvent(int x);

	public abstract void paint(Graphics2D g2d, double Y, Font font);

	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer("EventEntity: startTime = ");
		
		if(getStartTimeInfo() == null) {
			buffer.append(" null ");
		} else {
			buffer.append(getStartTimeInfo().getMovieTime());
		}
		
		buffer.append(", endTime = ");		
		if(getEndTimeInfo() == null) {
			buffer.append(" null ");
		} else {
			buffer.append(getEndTimeInfo().getMovieTime());
		}
		return buffer.toString();
	}

//	public boolean isValueStartTimeLocked() {
//		return lockedStart;
//	}

//	public void lockValueStartTime() {
//		this.valueStartTimeLocked = true;
//	}
//
//	public void unlockValueStartTime() {
//		this.valueStartTimeLocked = false;
//	}

//	public boolean isValueEndTimeLocked() {
//		return lockedEnd;
//	}

//	public void lockValueEndTime() {
//		this.valueEndTimeLocked = true;
//	}
//
//	public void unlockValueEndTime() {
//		this.valueEndTimeLocked = false;
//	}
//
//	public boolean isInitialHoldStartTimeLocked() {
//		return lockedStart;
//	}
//
//	public void lockInitialHoldStartTime() {
//		this.initialHoldStartTimeLocked = true;
//	}
//
//	public void unlockInitialHoldStartTime() {
//		this.initialHoldStartTimeLocked = false;
//	}

//	 public boolean isInitialHoldEndTimeLocked() {
//		 return lockedEnd;
//	 }
//	
	// public void initialHoldLockEndTime() {
	// this.initialHoldEndTimeLocked = true;
	// }
	//
	// public void initialHoldUnlockEndTime() {
	// this.initialHoldEndTimeLocked = false;
	// }

	// public void unlockFinalHoldStartTime() {
	// this.finalHoldStartTimeLocked = false;
	// }

//	public boolean isFinalHoldEndTimeLocked() {
//		return lockedEnd;
//	}

//	public void lockFinalHoldEndTime() {
//		this.finalHoldEndTimeLocked = true;
//	}
//
//	public void unlockFinalHoldEndTime() {
//		this.finalHoldEndTimeLocked = false;
//	}

	@Override
	public void highlight() {
		this.highlighted = true;
	}

	@Override
	public void unhighlight() {
		this.highlighted = false;
	}

   public Field getField() {
      return field;
   }

   public void setField(Field field) {
      this.field = field;
   }
   
   public PresentationEventsEntity getParentEntity() {
	   return parentEntity;
   }
   
   public void setParentEntity(PresentationEventsEntity parentEntity) {
	   this.parentEntity = parentEntity;
   }
   
   // call this function when EventsEntity subclass is created dynamically (i.e. not from db parsing, etc)
   public void determineParentEntity() {
	   PresentationField parentField = field.getParentField();
	   PresentationEventsEntity parentEntity = null;
	   
	   if (parentField == null || this instanceof PresentationEventsEntity){
		   return;
	   }
	   
	   int startCoord = this.getStartTimeCoordinate();	   
	   
	   parentEntity = (PresentationEventsEntity) parentField.getEventAt(startCoord);
	   
	   setParentEntity(parentEntity);
   }

//   public int getAfterCompoundID() {
//      return afterCompoundID;
//   }
//
//   public int getBeforeCompoundID() {
//      return beforeCompoundID;
//   }
//
//   public void setAfterCompoundID(int i) {
//      afterCompoundID = i;
//   }
//
//   public void setBeforeCompoundID(int i) {
//      beforeCompoundID = i;
//   }
}
