package edu.bu.signstream.grepresentation.fields.freeTextField;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEvent;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class FreeTextEvent extends GlossChainedEvent {
	private int length = 0;

	public FreeTextEvent(SS3Item item, SignStreamSegmentPanel segmentPanel) {
		super(item, segmentPanel);
	}

	public FreeTextEvent(SignStreamSegmentPanel segmentPanel) {
		super(segmentPanel);
	}

	public void setLenght(int lenght) {
		this.length = lenght;
		setStartTime(getStartTimeInfo().getMovieTime());
	}

	// Event interface
	public void setStartTime(int startTime) {
		super.getStartTimeInfo().setMovieTime(startTime);
		if (length > 0) {
			int duration = (int) (length / segmentPanel.getZoomer()
					.getPixelsInTimeFrame());
			super.getEndTimeInfo().setMovieTime(startTime + duration);
		}
	}

	// Event interface
	@Override
	public void setStartTimeCoordinate(int coord) {
		int startTime = (int) (coord / segmentPanel.getZoomer()
				.getPixelsInTimeFrame());
		setStartTime(startTime);
	}
}
