package edu.bu.signstream.grepresentation.fields.freeTextField;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEvent;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsCollection;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualFieldWrapper;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.main.ToolBarPanels;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class FreeTextFieldWrapper extends NonManualFieldWrapper { // FieldWrapper {

	public FreeTextFieldWrapper(FreeTextField ftField,
			SignStreamSegmentPanel segmentPanel) {
		super(ftField, segmentPanel);
	}

	@Override
	public void mouseClickedAlt(Point point) {
	}

	// do nothing!!!
	@Override
	public void mouseRightClicked(Point point) {
	}

	@Override
	public void mouseLeftClicked(Point point) {
	}

	@Override
	public void mouseDblRightClicked(Point point, JPanel panel) {
		mouseDblClicked(point, panel);
	}

	@Override
	public void mouseDblLeftClicked(Point point, JPanel panel) {
		mouseDblClicked(point, panel);
	}

	@Override
	public void mouseClicked(Point point, JPanel panel) {
	}

	@Override
	public void mousePressedAlt(Point point, JPanel panel) {
		final JPopupMenu popup = new JPopupMenu();
		
		int xcoord = point.x;
		final int movieTimeClicked = this.getSignStreamSegmentPanel()
				.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(xcoord);

		String str = "";
		FreeTextEntity ent = null;
		ArrayList<FreeTextEntity> entities = field.getEntities();
		for (int i = 0; i < entities.size(); i++) {
			FreeTextEntity currentEnt = entities.get(i);
			int entStartTime = currentEnt.getStartTimeInfo().getMovieTime();
			int entEndTime = currentEnt.getEndTimeInfo().getMovieTime();
			
			if (entStartTime <= movieTimeClicked && movieTimeClicked <= entEndTime) {
				ent =currentEnt;
				str = ent.getTextValue().getText();
				break;
			}
		}
		
		Event utterance = null;
		int utteranceStartTime = 0;
		int utteranceEndTime = 0;
		
		if (ent == null) {
			PresentationField parentField = field.getParentField();
			utterance = parentField.getEventAt(xcoord);
		} else {
			utterance = ent.getParentEntity();
		}
		
		if (utterance != null) {
			utteranceStartTime = utterance.getStartTimeInfo().getMovieTime();
			utteranceEndTime = utterance.getEndTimeInfo().getMovieTime();
		} else
			return;

		final Event parentEvent = utterance;

		final JTextField labelTextField = new JTextField();
		labelTextField.setText(str);
		labelTextField.setPreferredSize(new Dimension(700, 17));
		labelTextField.setBounds(new Rectangle(0, 0, 0, 0));
		labelTextField.setBackground(UIPalette.getBackground());
		labelTextField.setForeground(Color.black);
		labelTextField.setSize(5, 10);
		popup.setBounds(0, 0, 0, 0);
		popup.setBorder(BorderFactory.createEmptyBorder());
		popup.setBackground(UIPalette.getBackground());
		popup.add(labelTextField);

		PopupMenuListener popupMenuListener = new NewTextPopupMenuListener(
				labelTextField, segmentPanel);
		popup.addPopupMenuListener(popupMenuListener);

		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				labelTextField.requestFocus();
			}
		});

		labelTextField.addKeyListener(new KeyAdapter() {

			@Override
			public void keyReleased(KeyEvent e) {
				String txtStr = labelTextField.getText();
				FreeTextEntity ent = null;

				ArrayList<FreeTextEntity> entities = field.getEntities();
				for (int i = 0; i < entities.size(); i++) {
					FreeTextEntity currentEnt = entities.get(i);
					int entStartTime = currentEnt.getStartTimeInfo().getMovieTime();
					int entEndTime = currentEnt.getEndTimeInfo().getMovieTime();
					
					if (entStartTime <= movieTimeClicked && movieTimeClicked <= entEndTime) {
						ent =currentEnt;
						break;
					}
				}

				if (ent == null) {
					ChainedEventsCollection collection = new ChainedEventsCollection();
					SS3Item item = new SS3Item();
					item.setText(txtStr);
					
					ToolBarPanels panels = segmentPanel.getToolBarPanels();
					MediaToolBar mediaTb = panels.getMediaToolBar();
					Event pEvent = parentEvent;
					
					TimeInfo startTimeInfo = pEvent.getStartTimeInfo();
					TimeInfo clonedStartTimeInfo = startTimeInfo.cloneTimeInfo();					
					TimeInfo endTimeInfo = pEvent.getEndTimeInfo();
					TimeInfo clonedEndTimeInfo = endTimeInfo.cloneTimeInfo();
							
//					long packetDuration = segmentPanel.getZoomer().getCoordinateTimeConvertor().getPacketDuration();
//					
//					if(packetDuration <= 0) {
//						packetDuration = 1001; 
//					}
//
//					// this has made all the FreeTextEntity's saved in the db with the WRONG TIME
//					long startTime = clonedStartTimeInfo.getMovieTime() + 2*packetDuration;
//					long endTime = clonedEndTimeInfo.getMovieTime() + 2*packetDuration;

					long startTime = clonedStartTimeInfo.getMovieTime();
					long endTime = clonedEndTimeInfo.getMovieTime();
						
					clonedStartTimeInfo.setMovieTime((int)startTime);
					clonedEndTimeInfo.setMovieTime((int)endTime);
					
					item.setStartTimeInfo(clonedStartTimeInfo);
					item.setEndTimeInfo(clonedEndTimeInfo);
					
					GlossChainedEvent textValue = new GlossChainedEvent(item, segmentPanel);
					collection.setTextValueEvent(textValue);
					ent = new FreeTextEntity(collection, field.getFieldID(),
							segmentPanel, field);
					ent.determineParentEntity();
					ent.setValidTime(true);
					((FreeTextField) field).addFreeTextEntity(ent);
				}

				ent.getTextValue().setText(txtStr);

				if (e.getKeyCode() == 10) {
					// if blank text on enter, it means we want to delete the free text entity from the wrapper and the database
					if (txtStr == null || txtStr.isEmpty()) {
						field.deleteEntity(ent);
					}
					
					popup.setVisible(false);
					segmentPanel.repaint();
				}
			}

			@Override
			public void keyTyped(KeyEvent e) {
			}

			@Override
			public void keyPressed(KeyEvent e) {
			}
		});

		popup.setPreferredSize(popup.getPreferredSize());
		int y = field.getY() - 11;

		SS3Singleton.getApplicationStateController()
				.setLoadedCollectionUpdated(true);

		popup.show(panel, xcoord, y);
		popup.setVisible(true);
		
		labelTextField.addFocusListener(new FocusListener() {
			@Override
			public void focusGained(FocusEvent e) {
			}
			@Override
			public void focusLost(FocusEvent e) {
				popup.setVisible(false);
			}		
		});
	}

	public void mouseDblClicked(Point point, JPanel panel) {
		mousePressedAlt(point, panel);
	}

	// MouseMotionListener
	@Override
	public void mouseMoved(Point point, JPanel panel) {
		if (!isEntitySelected()) {
			Event event = nmField.getEventAt(point.x);
			if (event != null) {
				GlossChainedEvent glsEvent = (GlossChainedEvent) event;
				panel.setToolTipText(glsEvent.getText());
			} else {
				panel.setToolTipText(null);
			}
			panel.setCursor(new Cursor(getCursorType(point)));
		}
	}

	@Override
	public void mouseDragged(Point point, JPanel panel) {
	}

	@Override
	public int getCursorType(Point point) {
		return Cursor.DEFAULT_CURSOR;
	}
}

class NewTextPopupMenuListener implements PopupMenuListener {
	private SignStreamSegmentPanel segmentPanel = null;
	private JTextField labelTextField = null;

	NewTextPopupMenuListener(JTextField labelTextField, //Field nmField,
			SignStreamSegmentPanel segmentPanel) {
		this.segmentPanel = segmentPanel;
		this.labelTextField = labelTextField;
	}

	@Override
	public void popupMenuCanceled(PopupMenuEvent popupMenuEvent) {
		removeListeners(popupMenuEvent);
		segmentPanel.repaint();
	}

	@Override
	public void popupMenuWillBecomeInvisible(PopupMenuEvent popupMenuEvent) {
		removeListeners(popupMenuEvent);
	}

	private void removeListeners(PopupMenuEvent popupMenuEvent) {
		java.awt.event.KeyListener[] listeners = labelTextField
				.getKeyListeners();
		for (int i = 0; i < listeners.length; i++) {
			java.awt.event.KeyListener listener = listeners[i];
			labelTextField.removeKeyListener(listener);
		}

		labelTextField = null;

		JPopupMenu menu = (JPopupMenu) popupMenuEvent.getSource();
		menu.removePopupMenuListener(this);

		System.gc();
	}

	@Override
	public void popupMenuWillBecomeVisible(PopupMenuEvent popupMenuEvent) {
	}
}