package edu.bu.signstream.grepresentation.fields.glossField;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JPopupMenu;
import javax.swing.JTextField;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

class TextKeyListener extends KeyAdapter {
	boolean isText = false;
	private EnteredText enteredText = null;
	private GlossChainedEvent glsEvent = null;
	private JPopupMenu popup = null;
	
	TextKeyListener(JPopupMenu popup) {
		this.popup = popup;
	}
	
	public void setSelectedEvent(GlossChainedEvent glsEvent) {
		this.isText = false;
		this.glsEvent = glsEvent;
	}
	
	public void setEnteredText(EnteredText enteredText) {
		this.isText = true;
		this.enteredText = enteredText;
	}
	
	@Override
	public void keyReleased(KeyEvent e) {
		JTextField textField = (JTextField) e.getSource();
		String text = textField.getText();
		
		if(isText) {
			enteredText.setText(text);
		} else {
			glsEvent.setText(text);
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);

		if (e.getKeyCode() == 10) {
			popup.setVisible(false);
			SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
		}
	}

	@Override
	public void keyTyped(KeyEvent e) {
		;
	}

	@Override
	public void keyPressed(KeyEvent e) {
		;
	}
}