package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.glossField.GlossFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.nonManualField.GlossEntityProperties;

public class HandShapeFormBean {
	private SS3CodingScheme cs = null;
	private GlossFieldWrapper glsFieldWrapper = null;

	private boolean rightHandDominant = true;

	private boolean rightHandEnabled = true;
	private boolean leftHansEnabled = true;

	private boolean fingerspelledEnabled = true;
	private boolean fingerspelledSelected = false;
	private boolean fingerspelledREnabled = true;
	private boolean fingerspelledLEnabled = true;
	private boolean fingerspelledR = false;
	private boolean fingerspelledL = false;

	private boolean oneHandedEnabled = true;
	private boolean oneHandedSelected = false;
	private boolean oneHandedREnabled = true;
	private boolean oneHandedLEnabled = true;
	private boolean oneHandedR = false;
	private boolean oneHandedL = false;

	private boolean twoHandedEnabled = true;
	private boolean twoHandedSelected = false;
	private boolean twoHandedR = false;
	private boolean twoHandedL = false;

	private boolean sameHndshapesEnabled = true;
	private boolean sameHndshapesSelected = false;

	private boolean difHndshapesEnabled = true;
	private boolean difHndshapesSelected = false;

	private boolean markedForm = false;

	private char type;

	private ArrayList<HandShapeImage> slctRightHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> slctLeftHandShapeImages = new ArrayList<HandShapeImage>();
	
	private GlossEntityProperties properties;
	
	public void setGlossEntityProperties(GlossEntityProperties properties) {
		this.properties = properties;
	}
	
	public GlossEntityProperties getGlossEntityProperties() {
		return properties;
	}

	public SS3CodingScheme getSS3CodingScheme() {
		return cs;
	}

	public void setSS3CodingScheme(SS3CodingScheme cs) {
		this.cs = cs;
	}

	public boolean isRightHandSelected() {
		if (fingerspelledSelected && fingerspelledR) {
			return fingerspelledR;
		} else if (oneHandedSelected && oneHandedR) {
			return oneHandedR;
		}
		return false;
	}

	public void setSelectedRightHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctRightHandShapeImages.clear();
		this.slctRightHandShapeImages.addAll(handShapes);
	}

	public void setSelectedLeftHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctLeftHandShapeImages.clear();
		this.slctLeftHandShapeImages.addAll(handShapes);
	}

	public ArrayList<HandShapeImage> getSelectedRightHandShapeImages() {
		return slctRightHandShapeImages;
	}

	public ArrayList<HandShapeImage> getSelectedLeftHandShapeImages() {
		return slctLeftHandShapeImages;
	}

	/**
	 * @return
	 */
	public boolean isDifHndshapesEnabled() {
		return difHndshapesEnabled;
	}

	/**
	 * @return
	 */
	public boolean isDifHndshapesSelected() {
		return difHndshapesSelected;
	}

	/**
	 * @return
	 */
	public boolean isFingerspelledEnabled() {
		return fingerspelledEnabled;
	}

	/**
	 * @return
	 */
	public boolean isFingerspelledL() {
		return fingerspelledL;
	}

	/**
	 * @return
	 */
	public boolean isFingerspelledR() {
		return fingerspelledR;
	}

	/**
	 * @return
	 */
	public boolean isFingerspelledSelected() {
		return fingerspelledSelected;
	}

	/**
	 * @return
	 */
	public boolean isOneHandedEnabled() {
		return oneHandedEnabled;
	}

	/**
	 * @return
	 */
	public boolean isOneHandedL() {
		return oneHandedL;
	}

	/**
	 * @return
	 */
	public boolean isOneHandedR() {
		return oneHandedR;
	}

	/**
	 * @return
	 */
	public boolean isOneHandedSelected() {
		return oneHandedSelected;
	}

	/**
	 * @return
	 */
	public boolean isSameHndshapesEnabled() {
		return sameHndshapesEnabled;
	}

	/**
	 * @return
	 */
	public boolean isSameHndshapesSelected() {
		return sameHndshapesSelected;
	}

	/**
	 * @return
	 */
	public boolean isTwoHandedEnabled() {
		return twoHandedEnabled;
	}

	/**
	 * @return
	 */
	public boolean isTwoHandedL() {
		return twoHandedL;
	}

	/**
	 * @return
	 */
	public boolean isTwoHandedR() {
		return twoHandedR;
	}

	/**
	 * @return
	 */
	public boolean isTwoHandedSelected() {
		return twoHandedSelected;
	}

	/**
	 * @param b
	 */
	public void setDifHndshapesEnabled(boolean b) {
		difHndshapesEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setDifHndshapesSelected(boolean b) {
		difHndshapesSelected = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledEnabled(boolean b) {
		fingerspelledEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledL(boolean b) {
		fingerspelledL = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledR(boolean b) {
		fingerspelledR = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledSelected(boolean b) {
		fingerspelledSelected = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedEnabled(boolean b) {
		oneHandedEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedL(boolean b) {
		oneHandedL = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedR(boolean b) {
		oneHandedR = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedSelected(boolean b) {
		oneHandedSelected = b;
	}

	/**
	 * @param b
	 */
	public void setSameHndshapesEnabled(boolean b) {
		sameHndshapesEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setSameHndshapesSelected(boolean b) {
		sameHndshapesSelected = b;
	}

	/**
	 * @param b
	 */
	public void setTwoHandedEnabled(boolean b) {
		twoHandedEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setTwoHandedL(boolean b) {
		twoHandedL = b;
	}

	/**
	 * @param b
	 */
	public void setTwoHandedR(boolean b) {
		twoHandedR = b;
	}

	/**
	 * @param b
	 */
	public void setTwoHandedSelected(boolean b) {
		twoHandedSelected = b;
	}

	/**
	 * @return
	 */
	public boolean isRightHandDominant() {
		return rightHandDominant;
	}

	/**
	 * @param b
	 */
	public void setRightHandDominant(boolean b) {
		rightHandDominant = b;
	}

	/**
	 * @param c
	 */
	public void setType(char c) {
		type = c;
	}

	/**
	 * @return
	 */
	public boolean isLeftHansEnabled() {
		return leftHansEnabled;
	}

	/**
	 * @return
	 */
	public boolean isRightHandEnabled() {
		return rightHandEnabled;
	}

	/**
	 * @param b
	 */
	public void setLeftHansEnabled(boolean b) {
		leftHansEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setRightHandEnabled(boolean b) {
		rightHandEnabled = b;
	}

	/**
	 * @return
	 */
	public boolean isFingerspelledLEnabled() {
		return fingerspelledLEnabled;
	}

	/**
	 * @return
	 */
	public boolean isFingerspelledREnabled() {
		return fingerspelledREnabled;
	}

	/**
	 * @return
	 */
	public boolean isOneHandedLEnabled() {
		return oneHandedLEnabled;
	}

	/**
	 * @return
	 */
	public boolean isOneHandedREnabled() {
		return oneHandedREnabled;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledLEnabled(boolean b) {
		fingerspelledLEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledREnabled(boolean b) {
		fingerspelledREnabled = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedLEnabled(boolean b) {
		oneHandedLEnabled = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedREnabled(boolean b) {
		oneHandedREnabled = b;
	}

	/**
	 * @return
	 */
	public boolean isMarkedForm() {
		return markedForm;
	}

	/**
	 * @param b
	 */
	public void setMarkedForm(boolean b) {
		markedForm = b;
	}

	/**
	 * @return
	 */
	public char getType() {
		return type;
	}

	/**
	 * @return
	 */
	public GlossFieldWrapper getGlsFieldWrapper() {
		return glsFieldWrapper;
	}

	/**
	 * @param wrapper
	 */
	public void setGlsFieldWrapper(GlossFieldWrapper wrapper) {
		glsFieldWrapper = wrapper;
	}
}
