package edu.bu.signstream.grepresentation.fields.glossField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.ScrollPaneConstants;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.LettersHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.NumbersHandshapesPallet;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.PaletteUtil;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.SortedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.UnmarkedHandshapesPellet;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.SelectedHandshapesPanel;
import edu.bu.signstream.ui.ButtonPanel;

public class GeneralHandshapePalette extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private SS3CodingScheme scheme;
	private HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();
	private SelectedHandshapesPanel panel = null;
	private JPanel client = null;
	protected JScrollPane sp = null;

	private JButton clean = new JButton("Clear");
	
	private JPanel iconPanel = new JPanel();
	
	private ArrayList<SS3FieldValue> values = new ArrayList<SS3FieldValue>();
	private ArrayList<HandShapeImage> selectedHshImages = new ArrayList<HandShapeImage>();
	
	private PaletteUtil paletteUtil = null;

	public GeneralHandshapePalette(ArrayList<SS3FieldValue> values, ArrayList<HandShapeImage> selectedHshImages, SS3CodingScheme scheme, int selectedIndex, HandShapePanel hsPanel) {
		this.scheme = scheme;
		this.values = values;
		this.selectedHshImages.addAll(selectedHshImages);
		if (values == null) {
			panel = new SelectedHandshapesPanel(scheme);
		} else {
			panel = new SelectedHandshapesPanel(selectedHshImages, scheme, hsPanel);
		}
		
		this.paletteUtil = new PaletteUtil(scheme, panel);
		
		setPalette(selectedIndex);
		initUI(values);
	}

	public void setPalette(int selectedIndex) {
       
        if(selectedIndex == 0) {
        	//all
        	iconPanel = new SortedHandshapesPalette(values, paletteUtil);
        } else if(selectedIndex == 1) {
        	//letters
        	iconPanel = new LettersHandshapesPalette(values, paletteUtil,  selectedHshImages);
        	panel.setLettersHandshapesPallet((LettersHandshapesPalette)iconPanel);
        } else if(selectedIndex == 2) {
        	//numbers
        	iconPanel = new NumbersHandshapesPallet(values, panel, scheme);
        } else {
        	//unmarked
        	iconPanel = new UnmarkedHandshapesPellet(values, panel, scheme); 
        }
        
        removeAll();
        
        initUI(values);
        invalidate();
        revalidate();
	}
	
	private void initUI(ArrayList<SS3FieldValue> values) {			
		clean.addActionListener(this);
		
		sp = new JScrollPane(panel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

		sp.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);

		Dimension d = new Dimension(getPreferredSize().width+10, 50);
		Dimension spd = new Dimension(getPreferredSize().width - 50, 60);
		//Dimension spd = new Dimension(getPreferredSize().width - 150, 60);

		sp.setMaximumSize(spd);
		sp.setPreferredSize(spd);
		sp.setMinimumSize(spd);

		panel.setPreferredSize(d);

		client = new JPanel();
		client.setLayout(new BorderLayout(10, 10));
		client.add(sp, BorderLayout.SOUTH);

		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
		p.add(iconPanel, BorderLayout.CENTER);   
		p.add(client, BorderLayout.SOUTH);

		ButtonPanel bp = new ButtonPanel();
		bp.add(clean);

		setLayout(new BorderLayout());

		add(p, BorderLayout.CENTER);
		add(bp, BorderLayout.SOUTH);
	}

	public void setSelectedHshImages(ArrayList<HandShapeImage> selectedHshImages) {
        // panel = new SelectedHandshapesPanel(selectedHshImages);
		this.selectedHshImages.clear();
		this.selectedHshImages.addAll(selectedHshImages);
        panel.update(this.selectedHshImages);
    }

	@Override
	public void actionPerformed(ActionEvent ae) {
		panel.removeAll();
		
		if(iconPanel instanceof LettersHandshapesPalette) {
			LettersHandshapesPalette p = (LettersHandshapesPalette)iconPanel;
			p.clearEnteredIcons();
		}
	}

	public ArrayList<HandShapeImage> getSelectedHandshapes() {
		setSelectedHshImages(panel.getHandshapes());	// sets selectedHshImages
		return selectedHshImages;
	}

	public SelectedHandshapesPanel getSelectedHandshapesPanel() {
		return panel;
	}
}
