package edu.bu.signstream.grepresentation.fields.glossField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JDialog;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.listener.WeakWindowListener;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapeBean;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapePanel;

public class HandshapeDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private HandShapePanel panel = null;
    private HandshapePalette palette = null;

    public HandshapeDialog(HandShapesPaletteFormBean formBean,
			HandShapeBean bean, HandShapePanel panel, SS3CodingScheme scheme,
			JDialog dialog, int selectedIndex) {

		super(dialog, "Palette");
		super.setLocationRelativeTo(dialog);

		this.panel = panel;

        this.addWindowListener(new WeakWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                //dispose();
                setVisible(false);
            }
        }, this));

        palette = new HandshapePalette(formBean, bean, scheme, this, selectedIndex, panel);

        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout(50, 50));
        contentPane.add(palette, BorderLayout.CENTER);

        this.pack();
	}

    public void update(HandShapesPaletteFormBean formBean, HandShapeBean bean, int selectedIndex) {
        palette.update(formBean, bean, selectedIndex);
    }

//	private void init(HandShapesPaletteFormBean formBean, HandShapeBean bean,
//			SS3CodingScheme scheme, int selectedIndex) {
//		this.addWindowListener(new WeakWindowListener(new WindowAdapter() {
//			@Override
//			public void windowClosing(WindowEvent e) {
//				dispose();
//			}
//		}, this));
//
//		HandshapePalette pal = new HandshapePalette(formBean, bean, scheme,
//				this, selectedIndex, panel);
//
//		Container contentPane = getContentPane();
//		contentPane.setLayout(new BorderLayout(50, 50));
//		contentPane.add(pal, BorderLayout.CENTER);
//
//		this.pack();
//	}

	@Override
	public void dispose() {
		super.dispose();
		panel.updateSelectedIconsPanel();
		WindowListener[] windowListeners = this.getWindowListeners();
		for (int i = 0; i < windowListeners.length; i++) {
			WindowListener windowListener = windowListeners[i];
			this.removeWindowListener(windowListener);
		}
	}
	
	public HandshapePalette getPalette() {
		return palette;
	}
}
