package edu.bu.signstream.grepresentation.fields.handShapeField;

import java.io.*;
import java.awt.*;

import javax.swing.*;
import java.util.*;
import javax.imageio.*;

public class HandShapesImageManager {
	private HashMap loadedImageFiles = new HashMap();
	private HashMap loadedIcons = new HashMap();

	private String path = "handShapes"
			+ System.getProperty("file.separator", "/");

	// + "handShapes"
	// + System.getProperty("file.separator", "/");

	public HandShapesImageManager() {
	}

	public Image getImage(String fileName) {
		File file = getFile(fileName);
		Image image = null;

		try {
			image = ImageIO.read(file);
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return image;
	}

	public Icon getImageIcon(String fileName) {
		Object obj = loadedIcons.get(fileName);

		if (obj != null)
			return (Icon) obj;

		Icon icon = new ImageIcon(path + fileName);
		loadedIcons.put(fileName, icon);

		return icon;
	}

	public File getFile(String fileName) {
		Object obj = loadedImageFiles.get(fileName);

		if (obj != null)
			return (File) obj;

		return loadFile(fileName);
	}

	public File loadFile(String fileName) {
		if (fileName != null) {
			try {
				File file = new File(path + fileName);
				// lImg = ImageIO.read(file);
				loadedImageFiles.put(fileName, file);
				return file;
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		return null;
	}

    public Image getScaledImageInstance(String fileName, HandShapeEntity entity) {

        Image image = getImage(fileName);
        return image.getScaledInstance(image
                .getWidth(entity), 23, Image.SCALE_AREA_AVERAGING);
    }
}
