package edu.bu.signstream.grepresentation.fields.handShapeField.dialogs;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JDialog;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class GeneralHandShapeDialog extends JDialog implements ActionListener {
	private GeneralHandShapePanelClient parent;
	protected GeneralHandShapePallet hsPallet; //FingerspellingPallet fSpel;
	protected String fieldID = "";
	protected String title = "";
	private int type;
	
	private SS3CodingScheme scheme;

	private JButton save = new JButton("Save");
	private JButton cancel = new JButton("Cancel");

	private final int SAVE = 0;
	private final int CANCEL = 1;

	public GeneralHandShapeDialog(
		ArrayList handShapes,
		String title,
		String fieldID,
		GeneralHandShapePanelClient parent, SS3CodingScheme scheme) {

		super(SS3Singleton.getSignStreamApplication(), title);
		this.parent = parent;
		this.fieldID = fieldID;
		this.title = title;
		this.scheme = scheme;
		
		this.setResizable(false);

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				dispose();
			}
		});

		setPallet(handShapes, fieldID);

		save.setActionCommand("" + SAVE);
		cancel.setActionCommand("" + CANCEL);
		save.addActionListener(this);
		cancel.addActionListener(this);

		ButtonPanel bp = new ButtonPanel();
		bp.add(save);
		bp.add(cancel);
		bp.setSize(bp.getPreferredSize());

		Container contentPane = getContentPane();
		contentPane.add(hsPallet, BorderLayout.CENTER);
		contentPane.add(bp, BorderLayout.SOUTH);

		this.pack();
	}

	public void setType(int type) {
		this.type = type;
	}

	@Override
	public String getTitle() {
		return title;
	}

	protected void setPallet(ArrayList handShapes, String fieldID) {
		hsPallet = new GeneralHandShapePallet(handShapes, fieldID, scheme);
	}

	public SelectedHandshapesPanel getSelectedHandshapesPanel() {
		return hsPallet.getSelectedHandshapesPanel();
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case SAVE :
				NewHandShape hs = new NewHandShape();
				hs.setPanel(hsPallet.getSelectedHandshapesPanel());
				hs.setTitle(title);
				hs.setType(type);

				parent.addHandShape(hs);
				break;

			case CANCEL :
				parent.cancelNewHandShape();
				break;
		}
		dispose();
	}
}
