package edu.bu.signstream.grepresentation.fields.handShapeField.dialogs;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.*;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.handShapeField.*;

public class HandShapeTwoHandsPalet extends JPanel implements ActionListener {
	private HandShapePalletClient hsClient;
	private HashMap hm = new HashMap();
	private JRadioButton selectedEntity = new JRadioButton("Selected hand");
	private JRadioButton bothEntities = new JRadioButton("Both hands");
	private SS3CodingScheme scheme;
	
	public HandShapeTwoHandsPalet(
		ArrayList handshapes,
		HandShapePalletClient hsClient, SS3CodingScheme scheme) {
		this.hsClient = hsClient;
		this.scheme = scheme;

		JPanel northPanel = createNorthPanel();
		JPanel centerPanel = createPanel(handshapes);
		
		setLayout(new BorderLayout());
		add(northPanel, BorderLayout.NORTH);
		add(centerPanel, BorderLayout.CENTER);
	}

	private JPanel createNorthPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(0,3));
		panel.add(new JLabel("Add Handshape to: "));
		panel.add(selectedEntity);
		panel.add(bothEntities);
		
		ButtonGroup grp = new ButtonGroup();
		selectedEntity.setSelected(true);
		grp.add(selectedEntity);
		grp.add(bothEntities);
		
		return panel;
	}

	private JPanel createPanel(ArrayList handshapes) {
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(0, 10));

		HandShapesImageManager imageManager =
			SS3Singleton.getHandShapesImageManager();

		for (int i = 0; i < handshapes.size(); i++) {
			Object obj = handshapes.get(i);

			SS3FieldValue value = (SS3FieldValue) obj;
			String iid = value.getIid();

			SS3FieldTypeImg img = scheme.getImage(iid);
			hm.put(value.getId(), value);

			Icon icon = imageManager.getImageIcon(img.getPath1());

			Dimension d =
				new Dimension(
					icon.getIconWidth() + 2,
					icon.getIconHeight() + 2);

			JButton button = new JButton();
			button.setIcon(icon);
			button.setActionCommand(value.getId());
			button.setPreferredSize(d);
			button.setMaximumSize(d);
			button.setMaximumSize(d);
			button.setToolTipText(value.getLabel());
			panel.add(button);
			button.addActionListener(this);
		}
		return panel;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();
		SS3FieldValue value = (SS3FieldValue) hm.get(str);
		hsClient.setItem(value, bothEntities.isSelected());
	}
}