package edu.bu.signstream.grepresentation.fields.handShapeField.dialogs;

import java.util.*;

import java.awt.*;
import javax.swing.*;

import edu.bu.signstream.common.util.vo.Constants;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3Field;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;

public class SameHandShapePallet extends GeneralHandShapePallet {
	private SS3CodingScheme codingScheme;
	
	 private static final long serialVersionUID = 1L;
	
	public SameHandShapePallet(ArrayList list, String fieldID, SS3CodingScheme codingScheme) {
		super(list, fieldID, codingScheme);
		this.codingScheme = codingScheme;
		JPanel fldPanel = createSelectFieldPanel(fieldID);
		add(fldPanel, BorderLayout.NORTH);
	}
	
	private JPanel createSelectFieldPanel(String fieldID) {			
		SS3Field field = codingScheme.getField(fieldID);		
		String type = field.getType();		
		ArrayList<SS3Field> fields;
		
		if(type.equalsIgnoreCase(Constants.TYPE_RIGHT_HAND_SHAPE)) {
			fields = codingScheme.getFields(Constants.TYPE_LEFT_HAND_SHAPE);
		} else {
			fields = codingScheme.getFields(Constants.TYPE_RIGHT_HAND_SHAPE);
		}
		
		String[] flds = new String[fields.size()];	
		for(int i = 0; i < fields.size(); i++) {
			SS3Field fld = (SS3Field) fields.get(i);
			flds[i] = fld.getName();
		}
		
		JList<String> list = new JList<String>(flds);		
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(new JLabel("Select Second Hand Shape Field: "), BorderLayout.NORTH);
		panel.add(list, BorderLayout.CENTER);
		
		return panel;	
	}	
}
