package edu.bu.signstream.grepresentation.fields.locationField;

import java.awt.Font;
import java.awt.Graphics2D;
import java.util.ArrayList;

import edu.bu.signstream.common.util.CoordinateTimeConverter;
import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class LocationEntity extends EventsEntity {
   private LocationEventsCollection events = new LocationEventsCollection();

   public LocationEntity(
      LocationEventsCollection events,
      String fieldID,
      SignStreamSegmentPanel segmentPanel, Field field) {
      super(segmentPanel, field);
      this.events = events;
   }

   // private boolean attached = true;
   //
   // public void attach() {
   // this.attached = true;
   // }
   //
   // public void detach() {
   // this.attached = false;
   // }

   @Override
public SS3Entity getSS3Entity() {
      SS3Entity entity = new SS3Entity();
      return entity;
   }

   public void addLocationEvent(LocationEvent event) {
      events.addEvent(event);
   }

   public void setStartTime(int startTime) {
      getFirstEvent().getStartTimeInfo().setMovieTime(startTime);
   }

   public void setEndTime(int endTime) {
      getLastEvent().getEndTimeInfo().setMovieTime(endTime);
   }

   @Override
   public int getStartTimeCoordinate() {
      return getFirstEvent().getStartTimeCoordinate();
   }

   // should return Start Time Coordinate!!!
   @Override
public int getEndTimeCoordinate() {
      return getLastEvent().getStartTimeCoordinate();
   }

   @Override
public Event getFirstEvent() {
      return events.getFirstEvent();
   }

   @Override
public Event getLastEvent() {
      return events.getLastEvent();
   }

   public int getStartTime() {
      LocationEvent event = events.getFirstEvent();
      if (event == null)
         return 0;
      return event.getStartTimeInfo().getMovieTime();
   }

   public int getEndTime() {
      LocationEvent event = events.getLastEvent();
      if (event == null)
         return 0;
      return event.getEndTimeInfo().getMovieTime();
   }

   @Override
public boolean selectEntityIfEventSelected() {
      if (events.getSelectedEvent() != null) {
         select();
         return true;
      }
      return false;
   }

   public ArrayList getEvents() {
      return events.getEvents();
   }

   // i don't know how to do it - b. l.
   @Override
public boolean selectEventIfEntitySelected() {
      // if (selected) {
      // manager.unselectEntity();
      // //ChainedEvent valueEvent =
      // // manager.getChainedEventsCollection().getValueEvent();
      //				
      // manager.selectChainedEvent(valueEvent);
      // selected = false;
      // return true;
      // }
      return false;
   }

   @Override
public boolean select() {
      // manager.highlightEntity(Palette.HIGHLIGHTED_ENTITY_COLOR);

      // QTMultiMovieController qtControl =
      // SSSingleton.getMultiMovieController();
      // qtControl.setStartTime((int) manager.getFirstEvent().getStartTime());
      // qtControl.setEndTime((int) manager.getLastEvent().getEndTime());
      selected = true;
      // mToolBar.setEnable(true);
      return selected;
   }

   @Override
public boolean unselect() {
      selected = false;
      // mToolBar.setEnable(false);
      events.unselectEntity();
      return selected;
   }
   
   @Override
public boolean adjustEntity(int x1, int x2) {
      CoordinateTimeConverter convertor =
         segmentPanel.getZoomer().getCoordinateTimeConvertor();
      double startTime = convertor.convertCoordinateToTime(x1);
      double endTime = convertor.convertCoordinateToTime(x2);
      return events.adjustEntity((int) startTime, (int) endTime);
   }

   @Override
public Event getSelectedEvent() {
      if (selected)
         return this;
      return events.getSelectedEvent();
   }

   @Override
public void reset() {
      selected = false;
      // mToolBar.setEnable(false);
      events.resetAll();
   }

   @Override
public boolean delete() {
      return events.deleteAll();
   }

   @Override
public Event getEventAt(int x) {
      return events.getEventAt(x);
   }

   @Override
public String getToolTipText(int x) {
      LocationEvent event = events.getEventAt(x);

      if (event != null)
         return event.getToolTipText();
      return null;
   }

   public boolean setSelectedEventStartCoordinate(int coord) {
      // double time = coord / SegmentGraphReprUtil.pixelInTimeFrame;

      if (selected) {
         LocationEvent event = events.getFirstEvent();
         event.setStartTimeCoordinate(coord);
         return true;
      } else {
         LocationEvent sEvent = events.getSelectedEvent();
         sEvent.setStartTimeCoordinate(coord);
         return true;
      }
   }

   public boolean setSelectedEventEndCoordinate(int coord) {
      // double time = coord / SegmentGraphReprUtil.pixelInTimeFrame;

      if (selected) {
         LocationEvent event = events.getLastEvent();
         event.setEndTimeCoordinate(coord);
         return true;
      } else {
         LocationEvent sEvent = events.getSelectedEvent();
         sEvent.setStartTimeCoordinate(coord);
         return true;
      }
   }

   @Override
public boolean selectEvent(int x) {
      Event event = events.getEventAt(x);
      if (event == null)
         return false;
      return event.select();
   }

   @Override
public void paint(Graphics2D g2d, double Y, Font font) {
   }

   @Override
public ArrayList getEventsToAdd() {
      ArrayList list = new ArrayList();
      return list;
   }

   @Override
public String toString() {
      return "OrientationEntity: " + super.toString();
   }

   @Override
public TimeInfo getStartTimeInfo() {
      LocationEvent event = events.getFirstEvent();
      if (event == null)
         return null;
      return event.getStartTimeInfo();
   }

   @Override
public TimeInfo getEndTimeInfo() {
      LocationEvent event = events.getLastEvent();
      if (event == null)
         return null;
      return event.getEndTimeInfo();
   }

   @Override
public void setStartTimeInfo(TimeInfo startTimeInfo) {
      LocationEvent event = events.getFirstEvent();
      if (event != null)
         event.setStartTimeInfo(startTimeInfo);
   }

   @Override
public void setEndTimeInfo(TimeInfo endTimeInfo) {
      LocationEvent event = events.getLastEvent();
      if (event != null)
         event.setEndTimeInfo(endTimeInfo);
   }
}
