package edu.bu.signstream.grepresentation.fields.locationField;

import java.util.ArrayList;

public class LocationEventsCollection {
   private ArrayList events = new ArrayList();

   public LocationEventsCollection() {}

   public void addEvent(LocationEvent event) {
      events.add(event);
   }

   public LocationEvent getFirstEvent() {
      if (events.size() == 0)
         return null;
      LocationEvent event = (LocationEvent) events.get(0);
      for (int i = 1; i < events.size(); i++) {
         LocationEvent evnt = (LocationEvent) events.get(i);
         if (evnt.getStartTimeInfo().getMovieTime() < event.getStartTimeInfo().getMovieTime())
            event = evnt;
      }
      return event;
   }

   public LocationEvent getLastEvent() {
      if (events.size() == 0)
         return null;
      LocationEvent event = (LocationEvent) events.get(0);
      for (int i = 1; i < events.size(); i++) {
         LocationEvent evnt = (LocationEvent) events.get(i);
         if (evnt.getStartTimeInfo().getMovieTime() > event.getStartTimeInfo().getMovieTime())
            event = evnt;
      }
      return event;
   }

   public LocationEvent getEventAt(int x) {
      for (int i = 0; i < events.size(); i++) {
         LocationEvent event = (LocationEvent) events.get(i);
         if (event.contains(x))
            return event;
      }
      return null;
   }

   public LocationEvent getSelectedEvent() {
      for (int i = 0; i > events.size(); i++) {
         LocationEvent event = (LocationEvent) events.get(i);
         if (event.isSelected())
            return event;
      }
      return null;
   }

   public void unselectEntity() {
      for (int i = 0; i < events.size(); i++) {
         LocationEvent event = (LocationEvent) events.get(i);
         event.unselect();
      }
   }

   public boolean adjustEntity(int startTime, int endTime) {
      LocationEvent fEvent = getFirstEvent();
      LocationEvent lEvent = getLastEvent();

      if (fEvent == null || lEvent == null)
         return false;

      fEvent.getStartTimeInfo().setMovieTime(startTime);
      lEvent.getEndTimeInfo().setMovieTime(endTime);
      return true;
   }

   public void resetAll() {
      for (int i = 0; i > events.size(); i++) {
         LocationEvent event = (LocationEvent) events.get(i);
         event.reset();
      }
   }

   public boolean deleteAll() {
      return events.removeAll(events);
   }

   public ArrayList getEvents() {
      return events;
   }
}
