package edu.bu.signstream.grepresentation.fields.locationField;

import java.awt.Cursor;
import java.awt.Point;

import javax.swing.JPanel;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class LocationFieldWrapper extends FieldWrapper {
	private int MOVE_DIRECTION;
	private int MOVE_START_POINT = 1;
	private int MOVE_END_POINT = 2;

	private LocationField lField = null;
	public LocationFieldWrapper(LocationField field, SignStreamSegmentPanel segmentPanel) {
		super(field, segmentPanel);
		this.lField = field;
	}

	@Override
	public EventsEntity getEntityAt(int entityAt) {
		return lField.getEntityAt(entityAt);
	}

	@Override
	public void highlight(boolean highlight, String refID) {
		field.highlight(highlight, refID);
	}

	@Override
	public void addEventsEntity(EventsEntity entity) {
	}

	@Override
	public boolean contains(int Y) {
		return field.contains(Y);
	}

	// MouseListener
	@Override
	public void mouseClicked(Point point, JPanel panel) {
		EventsEntity entity = field.getEntityAt(point.x);
		if (entity != null)
			entity.select();
	}

	@Override
	public void mouseClickedAlt(Point point) {
	}
   
   @Override
public void mousePressedAlt(Point point, JPanel panel) {}

	@Override
	public void mouseRightClicked(Point point) {
	}

	@Override
	public void mouseLeftClicked(Point point) {
	}

	@Override
	public void mouseReleased(Point point, JPanel panel) {
	}

	@Override
	public void mouseDblLeftClicked(Point point, JPanel panel) {
		LocationEvent event = (LocationEvent) field.getEventAt(point.x);
		if (event != null) {
			SS3CodingScheme cs = SS3Singleton.getSS3CodingSchemeCollection().getDefaultCodingScheme();
         
			NewLocationDialog d = new NewLocationDialog(event, cs);
			d.setVisible(true);
		}
	}

	@Override
	public void mouseDblRightClicked(Point point, JPanel panel) {
	}

	//	public void mouseMoved(Point point, JPanel panel) {
	//		LocationEvent event = (LocationEvent) field.getEventAt(point.x);
	//		if (event != null) {
	//			event.getToolTipText();
	//			panel.setToolTipText(event.getToolTipText());
	//		} else {
	//			panel.setToolTipText("");
	//		}
	//	}

	@Override
	public void mouseMoved(Point point, JPanel panel) {
		//if (!isEntitySelected()) {
		panel.setCursor(new Cursor(getCursorType(point)));

		Event event = lField.getEventAt(point.x);
		if (event != null) {
			panel.setToolTipText(event.getToolTipText());
		} else {
			panel.setToolTipText("");
		}
		//}
	}

	private int getCursorType(Point point) {
		int cursorType = Cursor.DEFAULT_CURSOR;
		Event event = lField.getSelectedEntity(); // .getSelectedEvent();

		if (event != null) {
			int startCoord = event.getStartTimeCoordinate();
			int endCoord = event.getEndTimeCoordinate();

			if (startCoord - 3 < point.x && point.x < startCoord + 3) {
				cursorType = Cursor.E_RESIZE_CURSOR;
				MOVE_DIRECTION = MOVE_START_POINT;
			}

			if (endCoord - 3 < point.x && point.x < endCoord + 3) {
				cursorType = Cursor.E_RESIZE_CURSOR;
				MOVE_DIRECTION = MOVE_END_POINT;
			}
		}
		return cursorType;
	}

	@Override
	public void mouseDragged(Point point, JPanel panel) {
	}

	@Override
	public void unselectAll() {
		field.unselect();
	}

	@Override
	public void mouseHoldReleased(Point point, JPanel panel) {
	}
}
