package edu.bu.signstream.grepresentation.fields.nonManualField;

import java.awt.Color;

import edu.bu.signstream.common.util.CoordinateTimeConverter;
import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.main.Slider;

public class NewChainedEvent implements Event {
	private Color color = null;
	private boolean highlighted = false;

	private SignStreamSegmentPanel segmentPanel;

	private EventsEntity previousEntity = null;
	private EventsEntity nextEntity = null;
	
	private TimeInfo startTimeInfo = new TimeInfo();
	private TimeInfo endTimeInfo = new TimeInfo();

	public NewChainedEvent(int X1, SignStreamSegmentPanel segmentPanel) {
		this.segmentPanel = segmentPanel;

		CoordinateTimeConverter convertor = segmentPanel.getZoomer()
				.getCoordinateTimeConvertor();
		int movieStartTime = convertor.getAdjustedMovieTime(X1);
		
		startTimeInfo.setMovieTime(movieStartTime);
		endTimeInfo.setMovieTime(movieStartTime);
		moveSlider(X1);
	}

	public int getStartTime() {
		return startTimeInfo.getMovieTime();
	}

	public int getEndTime() {
		return endTimeInfo.getMovieTime();
	}

	public void setStartTime(int startTime) {
		startTimeInfo.setMovieTime(startTime);	
	}

	public void setEndTime(int endTime) {
		endTimeInfo.setMovieTime(endTime);
	}

	@Override
	public int getStartTimeCoordinate() {
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeToCoordinate(startTimeInfo.getMovieTime());
	}

	@Override
	public int getEndTimeCoordinate() {
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeToCoordinate(endTimeInfo.getMovieTime());
	}

	@Override
	public void setEndTimeCoordinate(int X2) {
		CoordinateTimeConverter convertor = segmentPanel.getZoomer()
				.getCoordinateTimeConvertor();
		int endTime = convertor.getAdjustedMovieTime(X2);
		
//		int endTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(X2);
		endTimeInfo.setMovieTime(endTime);
		moveSlider(X2);
	}

	@Override
	public void setStartTimeCoordinate(int X1) {
		//this.X1 = X1;

		CoordinateTimeConverter convertor = segmentPanel.getZoomer()
				.getCoordinateTimeConvertor();
		int startTime = convertor.getAdjustedMovieTime(X1);
		
//		int startTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(X1);
		startTimeInfo.setMovieTime(startTime);
	}

	@Override
	public boolean select() {
		return false;
	}

	@Override
	public boolean unselect() {
		return false;
	}

	@Override
	public void highlight() {
		this.highlighted = true;
	}

	@Override
	public void unhighlight() {
		this.highlighted = false;
	}

	@Override
	public boolean isHighlighted() {
		return highlighted;
	}

	private void moveSlider(int x) {
		Slider slider = segmentPanel.getSlider();

		if (slider != null)
			slider.setSliderPosition(x, true);
	}
	
	@Override
	public TimeInfo getStartTimeInfo() {
		return startTimeInfo;
	}

	@Override
	public TimeInfo getEndTimeInfo() {
		return endTimeInfo;
	}

	@Override
	public void setStartTimeInfo(TimeInfo startTimeInfo) {
		this.startTimeInfo = startTimeInfo;
	}

	@Override
	public void setEndTimeInfo(TimeInfo endTimeInfo) {
		this.endTimeInfo = endTimeInfo;
	}
	
	public EventsEntity getPreviousEntity() {
		return previousEntity;
	}

	public void setPreviousEntity(EventsEntity previousEntity) {
		this.previousEntity = previousEntity;
	}

	public EventsEntity getNextEntity() {
		return nextEntity;
	}

	public void setNextEntity(EventsEntity nextEntity) {
		this.nextEntity = nextEntity;
	}

	@Override
	public String getID() {
		return "";
	}

	@Override
	public void setID(String uniqueID) {
	}

	@Override
	public void setColor(Color color) {
		this.color = color;
	}

	@Override
	public Color getColor() {
		return color;
	}

	@Override
	public boolean isSelected() {
		return false;
	}

	@Override
	public String getToolTipText() {
		return "";
	}
}
