package edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.handShapeField.HandShapeEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class LockUnlockGlossPhonAlignmentsListener implements ActionListener {
	
	@Override
	public void actionPerformed(ActionEvent e) {
		GlossChainedEventsEntity selectedEntity  = (GlossChainedEventsEntity)SS3Singleton.getMediaToolBar(null).getSelectedEventsEntity();
		
		boolean locked = !selectedEntity.isLockedGlossPhonAlignments();
		
		ChainedEventsEntity depHandEntity = selectedEntity.getDependentHandEntity();
		HandShapeEntity depHandShapeEntity = selectedEntity.getDependentHandShapeEntity();
		
		if(locked) {
			int startTime = selectedEntity.getValueOrTextValueEvent().getStartTimeInfo().getMovieTime();
			int endTime = selectedEntity.getValueOrTextValueEvent().getEndTimeInfo().getMovieTime();
			
			ChainedEvent initHold = selectedEntity.getInitialHold();
			ChainedEvent finalHold = selectedEntity.getFinalHold();
			
			if(initHold != null)
				startTime = initHold.getStartTimeInfo().getMovieTime();
			
			if(finalHold != null)
				endTime = finalHold.getEndTimeInfo().getMovieTime();
				
			if(depHandEntity != null) {
				ChainedEventsEntity prevEntity = depHandEntity.getPreviousEntity();
				ChainedEventsEntity nextEntity = depHandEntity.getNextEntity();

				if((prevEntity == null || prevEntity.getEndTimeInfo().getMovieTime() <= startTime) 
						&& (nextEntity == null || nextEntity.getStartTimeInfo().getMovieTime() >= endTime)) {
					
					depHandEntity.getValueOrTextValueEvent().getStartTimeInfo().setMovieTime(startTime);
					depHandEntity.getValueOrTextValueEvent().getEndTimeInfo().setMovieTime(endTime);
					
					if(depHandShapeEntity != null) {
						depHandShapeEntity.setStartTime(startTime);
						depHandShapeEntity.setEndTime(endTime);
						depHandShapeEntity.setLockedGlossPhonAlignments(locked);
					}
					
					depHandEntity.setLockedGlossPhonAlignments(locked);
					SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
				} else {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CANT_LOCK_GLOSSES);
					return;
				}
			}
			
			selectedEntity.setLockedGlossPhonAlignments(locked);
			
		} else {
			selectedEntity.setLockedGlossPhonAlignments(locked);
			if(depHandEntity != null) {
				depHandEntity.setLockedGlossPhonAlignments(locked);
			}
			if(depHandShapeEntity != null) {
				depHandShapeEntity.setLockedGlossPhonAlignments(locked);
			}
			SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
		}
	}
}
