package edu.bu.signstream.grepresentation.listener;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.lang.ref.WeakReference;
import java.lang.reflect.Method;

public class WeakWindowListener implements WindowListener {  
	  
    private WeakReference<WindowListener> weakListenerReference;  
    private Object source;  
  
    public WeakWindowListener(WindowListener listener, Object source) {  
        this.weakListenerReference = new WeakReference<WindowListener>(listener);  
        this.source = source;  
    } 
    
    public void	windowActivated(WindowEvent e) {
    	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowActivated(e);
    }
    
    public void	windowClosed(WindowEvent e) {
     	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowClosed(e);
    }
    
    public void	windowClosing(WindowEvent e) {
      	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowClosing(e);
    }
    
    public void	windowDeactivated(WindowEvent e) {
       	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowDeactivated(e);
    }
    
    public void	windowDeiconified(WindowEvent e) {
       	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowDeiconified(e);
    }
    
    public void	windowIconified(WindowEvent e) {
       	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowIconified(e);
    }
    
    public void	windowOpened(WindowEvent e) {
    	WindowListener windowListener = getWindowListener();
    	if(windowListener != null)
    		windowListener.windowOpened(e);
    }
    
    private WindowListener getWindowListener() {
    	 WindowListener windowListener = (WindowListener) this.weakListenerReference.get();  
    	 if(windowListener == null)   
           this.removeListener();
    	 return windowListener;
    }
  
    private void removeListener() {  
        try {  
            Method method = source.getClass().getMethod("removeWindowListener", new Class[] {WindowListener.class});  
            method.invoke(source, new Object[] {this});  
        } catch(Exception ex) {  
            ex.printStackTrace();  
        }  
    }  
}  
