package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.swing.AbstractListModel;
import javax.swing.BorderFactory;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.common.util.vo.Palette;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.LabelViewIndependentItems.Listener;

public class LabelViewNonManualFields extends JPanel {
   
   /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
private LabelViewIndependentItems smoother; 
ArrayList<LabelObject> DATA = new ArrayList<LabelObject>();

   public LabelViewNonManualFields(
		   ArrayList<LabelObject> data,
      final SegmentGraphicRepresentation rep, SegmentControlPanel controlPanel) {
	   
	   DATA.clear();
	   for(LabelObject obj:data) {
		   DATA.add(obj);
	   }
	   
      final JList list = new JList(new AbstractListModel() {
         @Override
		public int getSize() {
            return DATA.size();
         }
         @Override
		public Object getElementAt(int index) {
            return DATA.get(index);
         }
      });

      list.setBackground(UIPalette.getBackground());

      smoother =
         new LabelViewIndependentItems(list) {
         @Override
		protected void move(int fromIndex, int toIndex) {
        	LabelObject o = DATA.remove(fromIndex);
            DATA.add(toIndex, o);
            list.revalidate();
            list.repaint();

            rep.getFieldWrappersCollection().moveField(fromIndex, toIndex);
            rep.repaint();
         }
      };

      Listener listener = new Listener(smoother);
      list.addMouseListener(listener);
      list.addMouseMotionListener(listener);          
      list.setSelectionBackground(UIPalette.getBackgroundSelection().darker());      
      list.getSelectionModel().addListSelectionListener(new ListSelectionHandler(list, controlPanel, rep));
      list.addKeyListener(SS3Singleton.getVideoControlKeyListener());		

      list.setCellRenderer(new DefaultListCellRenderer() {
         @Override
		public Component getListCellRendererComponent(
            JList list,
            Object value,
            int index,
            boolean sel,
            boolean focus) {
            Component c =
               super.getListCellRendererComponent(
                  list,
                  value,
                  index,
                  sel,
                  focus);
            
            JLabel label = (JLabel) c;
            label.setPreferredSize(
               new Dimension(200, SegmentGraphReprUtil.cellHeight));
            label.setBorder(new LineBorder(Palette.AXIS_COLOR));

            UserInterfaceUtil.setLabelLNF(label);
            
            LabelObject object = (LabelObject)value;
            if(object.isUpdatable()) {
               label.setForeground(Color.RED);
            }  else {
            	label.setForeground(Color.black);
            }

            if ((index % 2) == 0) {
               ((JComponent) c).setOpaque(true);
            } else if (c.getBackground().equals(list.getBackground())) {
               ((JComponent) c).setOpaque(false);
            }
            return c;
         }
      });

      setLayout(new BorderLayout());
      add(list, BorderLayout.CENTER);
   }
   
   public void update(ArrayList<LabelObject> data) {
	   DATA.clear();
	   for(LabelObject obj:data) {
		   System.out.println("data = " + data);
		   
		   DATA.add(obj);
	   }
   }
   
//   public void update(ArrayList<LabelObject> data, final SegmentGraphicRepresentation rep, SegmentConrolPanel controlPanel) {
//	   DATA.clear();
//	   for(LabelObject obj:data) {
//		   DATA.add(obj);
//	   }
//	   
//      final JList list = new JList(new AbstractListModel() {
//         public int getSize() {
//            return DATA.size();
//         }
//         public Object getElementAt(int index) {
//            return DATA.get(index);
//         }
//      });
//
//      list.setBackground(UIPalette.getBackground());
//
//      smoother =
//         new LabelViewIndependentItems(list) {
//         protected void move(int fromIndex, int toIndex) {
//            Object o = DATA.remove(fromIndex);
//            DATA.add(toIndex, o);
//            list.revalidate();
//            list.repaint();
//
//            rep.getFieldWrappersCollection().moveField(fromIndex, toIndex);
//            rep.repaint();
//         }
//      };
//
//      Listener listener = new Listener(smoother);
//      list.addMouseListener(listener);
//      list.addMouseMotionListener(listener);          
//      list.setSelectionBackground(UIPalette.getBackgroundSelection());      
//      list.getSelectionModel().addListSelectionListener(new ListSelectionHandler(list, controlPanel, rep));
//
//      list.setCellRenderer(new DefaultListCellRenderer() {
//         public Component getListCellRendererComponent(
//            JList list,
//            Object value,
//            int index,
//            boolean sel,
//            boolean focus) {
//            Component c =
//               super.getListCellRendererComponent(
//                  list,
//                  value,
//                  index,
//                  sel,
//                  focus);
//            
//            JLabel label = (JLabel) c;
//            label.setPreferredSize(
//               new Dimension(200, SegmentGraphReprUtil.cellHeight));
//            label.setBorder(new LineBorder(Palette.AXIS_COLOR));
//
//            UserInterfaceUtil.setLabelLNF(label);
//            
//            LabelObject object = (LabelObject)value;
//            if(object.isUpdatable()) {
//               label.setForeground(Color.RED);
//            }  else {
//            	label.setForeground(Color.black);
//            }
//
//            if ((index % 2) == 0) {
//               ((JComponent) c).setOpaque(true);
//            } else if (c.getBackground().equals(list.getBackground())) {
//               ((JComponent) c).setOpaque(false);
//            }
//            return c;
//         }
//      });
//
//      setLayout(new BorderLayout());
//      add(list, BorderLayout.CENTER);
//   }
   
   public LabelViewIndependentItems getLabelViewIndependentItems() {
      return smoother;
   } 

   public LabelViewNonManualFields(final List DATA) {

      final JList list = new JList(new AbstractListModel() {
         @Override
		public int getSize() {
            return DATA.size();
         }
         @Override
		public Object getElementAt(int index) {
            return DATA.get(index);
         }
      });

      list.setBackground(new Color(255, 247, 215));

      LabelViewIndependentItems smoother =
         new LabelViewIndependentItems(list) {
         @Override
		protected void move(int fromIndex, int toIndex) {
            Object o = DATA.remove(fromIndex);
            DATA.add(toIndex, o);
            list.revalidate();
            list.repaint();
         }
      };

      Listener listener = new Listener(smoother);
      list.addMouseListener(listener);
      list.addMouseMotionListener(listener);

      list.setCellRenderer(new DefaultListCellRenderer() {
         @Override
		public Component getListCellRendererComponent(
            JList list,
            Object value,
            int index,
            boolean sel,
            boolean focus) {
            Component c =
               super.getListCellRendererComponent(
                  list,
                  value,
                  index,
                  sel,
                  focus);
            Color bg = c.getBackground();

            c.setBackground(new Color(255, 247, 200));

            JLabel label = (JLabel) c;
            label.setPreferredSize(
               new Dimension(200, SegmentGraphReprUtil.cellHeight));
            label.setBorder(new LineBorder(Palette.AXIS_COLOR));

            if ((index % 2) == 0) {
               ((JComponent) c).setOpaque(true);
            } else if (c.getBackground().equals(list.getBackground())) {
               ((JComponent) c).setOpaque(false);
            }
            return c;
         }
      });

      String[] str =
         {
            "One",
            "Two",
            "Three",
            "Four",
            "Five",
            "Six",
            "Seven",
            "Eight",
            "Nine",
            "Ten" };
      JList cList = new JList(str);

      JScrollPane pictureScrollPane =
         new JScrollPane(
            cList,
            ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
            ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
      pictureScrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);

      pictureScrollPane.setPreferredSize(new Dimension(300, 250));

      pictureScrollPane.setViewportBorder(
         BorderFactory.createLineBorder(Color.black));

      pictureScrollPane.setRowHeaderView(list);
      pictureScrollPane.setCorner(ScrollPaneConstants.UPPER_LEFT_CORNER, new Corner());
      pictureScrollPane.setCorner(ScrollPaneConstants.LOWER_LEFT_CORNER, new Corner());
      pictureScrollPane.setCorner(ScrollPaneConstants.UPPER_RIGHT_CORNER, new Corner());

      setLayout(new BorderLayout());
      add(pictureScrollPane, BorderLayout.CENTER);
   }

   public static void main(String[] args) {
      JFrame f = new JFrame("Smooth List Drop");
      f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      List DATA =
         new ArrayList(
            Arrays.asList(
               new Object[] {
                  new LabelObject("1", " Happy"),
                  new LabelObject("2", " Bashful"),
                  new LabelObject("3", " Grumpy"),
                  new LabelObject("4", " Sneezy"),
                  new LabelObject("5", " Dopey"),
                  new LabelObject("6", " Sleepy"),
                  new LabelObject("7", " Doc"),
                  new LabelObject("8", " Snow White"),
                  new LabelObject("9", " Prince Charming"),
                  new LabelObject("10", " Wicked Witch"),
                  }));

      LabelViewNonManualFields panel = new LabelViewNonManualFields(DATA);

      JScrollPane jsp = new JScrollPane(panel);
      jsp.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
      f.getContentPane().add(jsp);
      f.pack();
      f.setVisible(true);
   }
}

class ListSelectionHandler implements ListSelectionListener {
	private JList list = null;
	private SegmentControlPanel controlPanel = null;
	private SegmentGraphicRepresentation rep = null;
	
	public ListSelectionHandler(JList list, SegmentControlPanel controlPanel, SegmentGraphicRepresentation rep) {
		this.list = list;
		this.rep = rep;
		this.controlPanel = controlPanel;
	}
	
    @Override
	public void valueChanged(ListSelectionEvent e) {
        Object obj = list.getSelectedValue();
        
        if(e.getValueIsAdjusting() && obj != null ) {
        	LabelObject labelObj = (LabelObject)obj;
        	
        	for(int i = 0; i < list.getModel().getSize(); i++) {
        	     Object obj1 = list.getModel().getElementAt(i);
        	     LabelObject labelObj1 = (LabelObject)obj1;
        	     labelObj1.getWrapper().setSelectedNHighlighted(false);
        	 }
        	
        	FieldWrapper wrapper = labelObj.getWrapper();
        	wrapper.setSelectedNHighlighted(true);
        	rep.repaint();
        }
    }
}
