package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.ArrayList;

import javax.swing.JPanel;

import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.fields.FieldWrappersCollection;
import edu.bu.signstream.grepresentation.fields.Segment;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.panels.codingScheme.CSFieldDialog;

public class NonManualFieldsLabelView extends JPanel {

	private LabelViewNonManualFields labelView = null;
	private SegmentGraphicRepresentation rep = null;
	private NonManualFieldsButtonPanel fieldsButtonPanel = null;
	private CSFieldDialog csFieldDialog = null;
	private SegmentControlPanel controlPanel = null;
	private SignStreamSegmentPanel segmentPanel = null;

	private ArrayList<LabelObject> labels = null;

	private Segment segment;

	public NonManualFieldsLabelView(Segment segment,
			SignStreamSegmentPanel panel, SegmentControlPanel controlPanel,
			CSFieldDialog csFieldDialog) {
		this.segmentPanel = panel;
		this.segment = segment;
		this.controlPanel = controlPanel;
		this.csFieldDialog = csFieldDialog;

		rep = new SegmentGraphicRepresentation(panel, segment);

		ArrayList<FieldWrapper> wrappers = segment.getFieldWrappersCollection()
				.getWrappers();
		FieldWrappersCollection wrappers1 = new FieldWrappersCollection();

		labels = segment.getRootLabelObject().getNonManuelLabelObject()
				.getVisibleObjects();

		for (int i = 0; i < labels.size(); i++) {
			LabelObject object = labels.get(i);
			// String fieldID = object.getFieldID();

			wrappers1.addFieldWrapper(object.getWrapper());

			// for(FieldWrapper wrapper:wrappers) {
			// if(fieldID.equalsIgnoreCase(wrapper.getField().getFieldID())) {
			// wrappers1.addFieldWrapper(wrapper);
			// }
			// }
		}
		
		fieldsButtonPanel = new NonManualFieldsButtonPanel(segmentPanel, this);

		rep.setFieldWrappersCollection(wrappers1);
		labelView = new LabelViewNonManualFields(labels, rep, controlPanel);

		removeAll();
		setLayout(new BorderLayout(0, 1));
		add(fieldsButtonPanel, BorderLayout.NORTH);
		add(labelView, BorderLayout.CENTER);
	}

	public void update(Segment segment) {
		this.segment = segment;

		rep.update();

		// ArrayList<FieldWrapper> wrappers =
		// segment.getFieldWrappersCollection().getWrappers();
		// FieldWrappersCollection wrappers1 = new FieldWrappersCollection();

		labels = segment.getRootLabelObject().getNonManuelLabelObject()
				.getVisibleObjects();

//		for (int i = 0; i < labels.size(); i++) {
//			LabelObject object = (LabelObject) labels.get(i);
//			wrappers1.addFieldWrapper(object.getWrapper());
//		}
//
//		rep.setFieldWrappersCollection(wrappers1);
//		labelView.update(labels, rep, controlPanel);
//		labelView.repaint();
		
		labelView = new LabelViewNonManualFields(labels, rep, controlPanel);

		add(labelView, BorderLayout.CENTER);
		// = new LabelViewNonManualFields(labels, rep, controlPanel);
	}

	public ArrayList<LabelObject> getLabels() {
		return labels;
	}

	public SegmentGraphicRepresentation getSegmentGraphicRepresentation() {
		return rep;
	}

	public CSFieldDialog getCSFieldDialog() {
		return csFieldDialog;
	}

	public void setPreferredHeight(int ph) {
		int size = getPreferredSize().width;
		setPreferredSize(new Dimension(size, ph));
	}

	public void setPreferredWidth(int pw) {
		int size = getPreferredSize().height;
		setPreferredSize(new Dimension(pw, size));
	}

	public void loadWrappers() {
		ArrayList<LabelObject> visibleObjects = 
				segment.getRootLabelObject().getNonManuelLabelObject().getVisibleObjects();
		FieldWrappersCollection collection = new FieldWrappersCollection();		
		
		for (LabelObject obj: visibleObjects) {
			FieldWrapper fieldWrapper = obj.getWrapper();
			fieldWrapper.setVisible(true);
			collection.addFieldWrapper(fieldWrapper);			
		}

		fieldsButtonPanel = new NonManualFieldsButtonPanel(segmentPanel, this);
		
		rep.setFieldWrappersCollection(collection);
		labelView = new LabelViewNonManualFields(visibleObjects, rep, controlPanel);

		removeAll();
		setLayout(new BorderLayout(0, 1));
		add(fieldsButtonPanel, BorderLayout.NORTH);
		add(labelView, BorderLayout.CENTER);
	}
	
	public LabelObject getSelectedField() {
		LabelObject selectedFieldLabel = 
				(LabelObject) labelView.getLabelViewIndependentItems().getList().getSelectedValue();
		return selectedFieldLabel;
	}
	
	void clickExpandButton() {
		fieldsButtonPanel.clickExpandButton();
	}
}
