package edu.bu.signstream.grepresentation.view;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.Icon;

import edu.bu.signstream.common.util.ImageMaker;
import edu.bu.signstream.grepresentation.fields.Segment;
import edu.bu.signstream.grepresentation.fields.presentation.dialog.RenameSegmentDialog;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class PresentationUpperLeftCorner
   extends Corner
   implements MouseListener, MouseMotionListener {

   private Rectangle newRect;
   //private Rectangle openRect;
   //private Rectangle undoRect;
   //private Rectangle redoRect;
   private Rectangle zoomInRect;
   private Rectangle zoomOutRect;

   private SignStreamSegmentPanel segmentPanel;
   private Segment segment;

   public PresentationUpperLeftCorner(SignStreamSegmentPanel segmentPanel, Segment segment) {
      this.segmentPanel = segmentPanel;
      this.segment = segment;
      addMouseListener(this);
      addMouseMotionListener(this);
   }
   
   @Override
protected void paintComponent(Graphics g) {
      super.paintComponent(g);
      Graphics2D g2d = (Graphics2D) g;
      try {
         Image newImg = ImageIO.read(new File(ImageMaker.CREATE_ICON));
         //Image openImg = ImageIO.read(new File(ImageMaker.OPEN_ICON));
         //implement undo & redo in next version
//         Image undoImg = ImageIO.read(new File(ImageMaker.UNDO_ICON));
//         Image redoImg = ImageIO.read(new File(ImageMaker.REDO_ICON));
         Image zoomInImg = ImageMaker.getZoomInIcon();
         Image zoomOutImg = ImageMaker.getZoomOutIcon();
                  
         g2d.setColor(Color.DARK_GRAY);
         int startCoord = 5;
         g2d.drawImage(newImg, startCoord, 5, Color.WHITE, this);
         newRect =
            new Rectangle(
               startCoord - 1,
               4,
               newImg.getWidth(this) + 1,
               newImg.getHeight(this) + 1);

         g2d.draw(newRect);

         //startCoord += redoImg.getWidth(this) + 5;
         //         g2d.drawImage(openImg, startCoord, 5, Color.WHITE, this);
         //         openRect =
         //            new Rectangle(
         //               startCoord - 1,
         //               4,
         //               openImg.getWidth(this) + 1,
         //               openImg.getHeight(this) + 1);

         //g2d.draw(openRect);

         startCoord += newImg.getWidth(this) + 5;
//         g2d.drawImage(undoImg, startCoord, 5, Color.WHITE, this);
//         undoRect =
//            new Rectangle(
//               startCoord - 1,
//               4,
//               undoImg.getWidth(this) + 1,
//               undoImg.getHeight(this) + 1);
//
//         g2d.draw(undoRect);
//
//         startCoord += undoImg.getWidth(this) + 5;
//         g2d.drawImage(redoImg, startCoord, 5, Color.WHITE, this);
//         redoRect =
//            new Rectangle(
//               startCoord - 1,
//               4,
//               redoImg.getWidth(this) + 1,
//               redoImg.getHeight(this) + 1);
//
//         g2d.draw(redoRect);
//
//         startCoord += redoImg.getWidth(this) + 5;
         g2d.drawImage(zoomInImg, startCoord, 5, Color.WHITE, this);
         zoomInRect =
            new Rectangle(
               startCoord - 1,
               4,
               zoomInImg.getWidth(this) + 1,
               zoomInImg.getHeight(this) + 1);

         g2d.draw(zoomInRect);

         startCoord += zoomInImg.getWidth(this) + 5;
         g2d.drawImage(zoomOutImg, startCoord, 5, Color.WHITE, this);
         zoomOutRect =
            new Rectangle(
               startCoord - 1,
               4,
               zoomOutImg.getWidth(this) + 1,
               zoomOutImg.getHeight(this) + 1);
         g2d.draw(zoomOutRect);

      } catch (Exception ex) {
         ex.printStackTrace();
      }
   }
   
   @Override
public void mouseMoved(MouseEvent e) {
      
      Point point = e.getPoint();
      if(newRect.contains(point)) {
         setToolTipText("Create New Statement");
      } else if(zoomInRect.contains(point)) {
         setToolTipText("Zoom In");
      } else if(zoomOutRect.contains(point)) {
         setToolTipText("Zoom Out"); 
      } else {
         setToolTipText(null); 
      }
      repaint();  
   }
   
   @Override
public void mouseDragged(MouseEvent e) {}

   @Override
public void mouseEntered(MouseEvent e) {}

   @Override
public void mouseExited(MouseEvent e) {}

   @Override
public void mousePressed(MouseEvent e) {}

   @Override
public void mouseReleased(MouseEvent e) {}

   //	select chained event or chained events entity
   @Override
public void mouseClicked(MouseEvent e) {
      Point point = e.getPoint();

//      if (newRect.contains(point.x, point.y)) {
//         CreateNewFieldDialog dialog = new CreateNewFieldDialog(segmentPanel, segment);
//         dialog.setLocation(150, 150);
//         dialog.show();
//      }

      //if (openRect.contains(point.x, point.y)) {
      //			Manager mngr = SS3Singleton.getManager();
      //
      //			CodingSchemeFieldsDialog dialog =
      //				new CodingSchemeFieldsDialog(mngr.getTest(), rep);
      //
      //			//dialog.setSize(200, 200);
      //			dialog.setLocation(150, 150);
      //			dialog.show();
      //}

//      if (undoRect.contains(point.x, point.y))
//         System.out.println(" --- UNDO --- ");
//
//      if (redoRect.contains(point.x, point.y))
//         System.out.println(" --- REDO --- ");

      if (zoomInRect.contains(point.x, point.y)) {
         //
         //
         System.err.println(
            "PresentationUpperLeftCorner: mouseClicked: zoom in");
         //
         //
         segmentPanel.getZoomer().zoomIn();
         segmentPanel.repaint();
         //SegmentGraphReprUtil.zoomIn();
         //SS3Singleton.getManager().getTest().repaint();
      }

      if (zoomOutRect.contains(point.x, point.y)) {
         //
         System.err.println(
            "PresentationUpperLeftCorner: mouseClicked: zoom out");
         //
         segmentPanel.getZoomer().zoomOut();
         segmentPanel.repaint();
         //SegmentGraphReprUtil.zoomOut();
         //SS3Singleton.getManager().getTest().repaint();
      }
   }
}

class NewSegmentIcon implements Icon{
    
    private int width = 32;
    private int height = 32;
    
    //private BasicStroke stroke = new BasicStroke(4);
    
    @Override
	public void paintIcon(java.awt.Component c,
            Graphics g,
            int x,
            int y){
    	Graphics2D g2d = (Graphics2D) g.create();
    	g2d.setColor(Color.black);
    	g2d.drawString("Segment", 1, 10);
    	
    }
 /*   
    public void paintIcon(Component c, Graphics g, int x, int y) {
        Graphics2D g2d = (Graphics2D) g.create();
        
        g2d.setColor(Color.WHITE);
        g2d.fillRect(x +1 ,y + 1,width -2 ,height -2);
        
        g2d.setColor(Color.BLACK);
        g2d.drawRect(x +1 ,y + 1,width -2 ,height -2);
        
        g2d.setColor(Color.RED);
        
        //g2d.setStroke(stroke);
        g2d.drawLine(x +10, y + 10, x + width -10, y + height -10);
        g2d.drawLine(x +10, y + height -10, x + width -10, y + 10);
        
        g2d.dispose();
    }
*/    
    @Override
	public int getIconWidth() {
        return width;
    }
    
    @Override
	public int getIconHeight() {
        return height;
    }
}
