package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JSlider;
import javax.swing.KeyStroke;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class UpperLeftCorner extends Corner {
	private static final long serialVersionUID = 1L;

	JSlider zoomInOut = new JSlider();

	public UpperLeftCorner(final SignStreamSegmentPanel segmentPanel) {

		zoomInOut.setMajorTickSpacing(20);
		zoomInOut.setMinorTickSpacing(5);
		zoomInOut.setPaintTicks(true);
		zoomInOut.setMaximum(100);
		zoomInOut.setMinimum(0);

		zoomInOut.getInputMap().put(KeyStroke.getKeyStroke("LEFT"), "none");
		zoomInOut.getInputMap().put(KeyStroke.getKeyStroke("RIGHT"), "none");
		
		zoomInOut.addKeyListener(SS3Singleton.getVideoControlKeyListener());		

		double pixelsInTimeFrame = segmentPanel.getZoomer()
				.getPixelsInTimeFrame();
		double sliderValue = pixelsInTimeFrame * 100 / 8.62;

		zoomInOut.setValue((int) sliderValue);
		zoomInOut.setPreferredSize(new Dimension(150, 30));
		zoomInOut.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent event) {
				int value = zoomInOut.getValue();
				if (segmentPanel.isUtteranceLoaded()) {
					segmentPanel.getUtteranceView().zoom(value);
				} else {
					segmentPanel.getDatabaseView().zoom(value);
				}
			}
		});

		setLayout(new BorderLayout());
		add(zoomInOut, BorderLayout.CENTER);
	}

	public void setValue(int value) {
		zoomInOut.setValue(value);
	}
}