package edu.bu.signstream.grepresentation.view.main;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.JToolBar;

import edu.bu.signstream.grepresentation.fields.glossField.Compoundable;
import edu.bu.signstream.grepresentation.fields.glossField.GlossField;
import edu.bu.signstream.media.fileNavigation.MediaDialog;

public class SegmentToolBarPanel extends JToolBar implements ActionListener,
		ItemListener {

	private static final long serialVersionUID = 1L;

	private SignStreamSegmentPanel panel;

	private JRadioButton itemBtn;
	private JRadioButton entityBtn;

	private final JButton mediaBtn;
	private final JButton convertBtn;
	private final JButton compoundBtn;

	private final int ITEM = 0;

	private final int ENTITY = 1;

	private final int MEDIA = 2;
	private final int CONVERT = 3;

	private final int COMPOUND = 4;

	private boolean createCompound = true;

	private ArrayList<Compoundable> compoundEvents;
	private GlossField field = null;

	public SegmentToolBarPanel(SignStreamSegmentPanel panel) {
		this.panel = panel;

		itemBtn = new JRadioButton("Item Level ");
		// itemBtn.setMnemonic(KeyEvent.VK_B);
		itemBtn.setActionCommand("" + ITEM);
		itemBtn.addItemListener(this);
		itemBtn.setSelected(true);

		entityBtn = new JRadioButton("Entity Level ");
		// itemBtn.setMnemonic(KeyEvent.VK_B);
		entityBtn.setActionCommand("" + ENTITY);
		entityBtn.addItemListener(this);
		entityBtn.setSelected(false);

		ButtonGroup grp = new ButtonGroup();
		grp.add(itemBtn);
		grp.add(entityBtn);

		mediaBtn = new JButton("Media");
		mediaBtn.addActionListener(this);
		mediaBtn.setActionCommand("" + MEDIA);

		convertBtn = new JButton("Convert");
		convertBtn.addActionListener(this);
		convertBtn.setActionCommand("" + CONVERT);

		compoundBtn = new JButton("Compound");
		compoundBtn.addActionListener(this);
		compoundBtn.setActionCommand("" + COMPOUND);

		setFloatable(false);

		// add(mediaBtn);
		// add(compoundBtn);
		// add(multipleSelection);
		// add(convertBtn);
	}

	/*
	 * public JCheckBox getMultipleSelection() { return multipleSelection; }
	 */
	// events - list of ChainedEventsEntity
	public void activateCompoundBn(ArrayList<Compoundable> events,
			GlossField field) {
		this.field = field;

		if (events == null || events.size() == 0) {
			compoundBtn.setEnabled(false);
			compoundBtn.setText("Compound");
			compoundBtn
					.setToolTipText("To create compound select gloss event(s).");
		} else {
			// ChainedEventsEntity entity = (ChainedEventsEntity)events.get(0);
			// if(entity.isStartCompound()) {
			// createCompound = false;
			// compoundBtn.setEnabled(true);
			// compoundBtn.setText("Unlink Compound");
			// compoundBtn.setToolTipText("Unlink Compound.");
			// } else {
			createCompound = true;
			compoundBtn.setEnabled(true);
			compoundBtn.setText("Create Compound");
			compoundBtn.setToolTipText("Create Compound.");
			// }
		}
		compoundEvents = events;
	}

	@Override
	public void itemStateChanged(ItemEvent event) {
//		JRadioButton obj = (JRadioButton) event.getSource();
//		String str = obj.getActionCommand();
//
//		Slider slider = panel.getSlider();
//		MediaToolBar mediaTb = panel.getToolBarPanels() != null ? panel
//				.getToolBarPanels().getMediaToolBar() : null;
//		// QTMultiMovieController controller =
//		// panel.getQTMultiMovieController();
//
//		Event selectedEvent = null;
//
//		switch (Integer.parseInt(str)) {
//		case ITEM:
//			if (itemBtn.isSelected()) {
//				panel.setEntityLevelSelected(false);
//
//				ArrayList<edu.bu.signstream.grepresentation.fields.Segment> segments = panel
//						.getSegments();
//				for (edu.bu.signstream.grepresentation.fields.Segment segment : segments) {
//					segment.selectItem();
//					selectedEvent = segment.getFieldWrappersCollection()
//							.getSelectedEvent();
//				}
//			}
//			break;
//
//		case ENTITY:
//			if (entityBtn.isSelected()) {
//				panel.setEntityLevelSelected(true);
//
//				ArrayList<edu.bu.signstream.grepresentation.fields.Segment> segments = panel
//						.getSegments();
//				for (edu.bu.signstream.grepresentation.fields.Segment segment : segments) {
//					segment.selectEntity();
//					selectedEvent = segment.getFieldWrappersCollection()
//							.getSelectedEntity();
//				}
//			}
//			break;
//		}
//
//		if (selectedEvent != null) {
//			if (mediaTb != null) {
//				mediaTb.selectEvent(selectedEvent);
//			}
//
//			if (slider != null) {
//				slider.setSliderPositionTime(selectedEvent.getStartTimeInfo()
//						.getMovieTime());
//			}
//
//			panel.getMultipleMovieController().selectSegment(
//					selectedEvent.getStartTimeInfo().getMovieTime(),
//					selectedEvent.getEndTimeInfo().getMovieTime());
//			panel.getMultipleMovieController().setCurrentTime(
//					selectedEvent.getStartTimeInfo().getMovieTime());
//
//		} else {
//			int startTime = 0, endTime = 0;
//
//			ArrayList<edu.bu.signstream.grepresentation.fields.Segment> segments = panel
//					.getSegments();
//			for (edu.bu.signstream.grepresentation.fields.Segment segment : segments) {
//				startTime = segment.getStartTime();
//				endTime = segment.getEndTime();
//			}
//
//			panel.getMultipleMovieController()
//					.selectSegment(startTime, endTime);
//			panel.getMultipleMovieController().setCurrentTime(startTime);
//		}
//
//		panel.repaint();
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
		case MEDIA:
			MediaDialog md = new MediaDialog(panel.getParentFrame(), panel);

//			if (panel.getParentFrame() != null) {
//				md = new MediaDialog(panel.getParentFrame(), panel);
//			} else {
//				md = new MediaDialog(panel.getParentDialog(), panel);
//			}
			md.setVisible(true);
			break;

		case COMPOUND:
			if (createCompound && compoundEvents != null
					&& compoundEvents.size() > 1) {
				String msg = null;

				for (int i = 0; i < compoundEvents.size() - 1; i++) {
					Compoundable comp0 = compoundEvents.get(i);
					Compoundable comp1 = compoundEvents.get(i + 1);
					comp0.setEndCompound(comp1);
					comp1.setStartCompound(comp0);

					int time1 = comp0.getEndTimeInfo().getMovieTime();
					int time2 = comp1.getStartTimeInfo().getMovieTime();
					if (time1 != time2)
						msg += "--- event # " + i + " end movie time equal "
								+ time1 + ", event # " + i + 1
								+ " start movie time equal " + time2 + "---\n";
				}

				Compoundable comp2 = compoundEvents
						.get(compoundEvents.size() - 2);
				Compoundable comp3 = compoundEvents
						.get(compoundEvents.size() - 1);
				comp2.setEndCompound(comp3);
				comp3.setStartCompound(comp2);
				int time3 = comp2.getEndTimeInfo().getMovieTime();
				int time4 = comp3.getStartTimeInfo().getMovieTime();
				if (time3 != time4) {
					int size = compoundEvents.size() - 1;
					msg += "--- event # " + size + " end movie time equal "
							+ time3 + ", event # " + size + 1
							+ " start movie time equal " + time4 + "---\n";
				}

				field.setSelectCompoundStartCoord(-1);
				field.setSelectCompoundEndCoord(-1);

			}
			panel.repaint();
			break;
		}
	}
}
