package edu.bu.signstream.grepresentation.view.main;

import edu.bu.signstream.common.util.CoordinateTimeConverter;

public class Zoomer {
	private CoordinateTimeConverter convertor;

	private double pixelInTimeFrame = 0.0124; // 0.10;
	
	private double dPixelInTimeFrame = 0.124;

	private double minPixelInTimeFramePresentation = 0.10;

	private double maxPixelInTimeFramePresentation = 10;

	public Zoomer() {
		this.convertor = new CoordinateTimeConverter(0, pixelInTimeFrame);
	}
	
	public void fillEntireUtterancePage(int clipDuration, int packetDuration, double width) {
		
		int w = convertor.getScreenWidth(clipDuration, dPixelInTimeFrame);
		double x = (width-10) / w;
	
		this.pixelInTimeFrame = (x * dPixelInTimeFrame);		
		convertor.setPixelInTimeFrame(this.pixelInTimeFrame);
		convertor.setPacketDuration(packetDuration);
	}
	
	public void fillEntirePage(int clipDuration, int packetDuration, double width) {				
		int w = convertor.getScreenWidth(clipDuration, dPixelInTimeFrame);
		double x = (width-10) / w;
			
		this.pixelInTimeFrame = (x * dPixelInTimeFrame);		
		convertor.setPixelInTimeFrame(this.pixelInTimeFrame);
		this.minPixelInTimeFramePresentation = this.pixelInTimeFrame;
		double mPixels = convertor.calculatePixelInTimeFrame(packetDuration, 5);
		this.maxPixelInTimeFramePresentation = mPixels;	
	}
	
	public double getMaxPixelInTimeFramePresentation() {
		return maxPixelInTimeFramePresentation;
	}
 
	public double getMinPixelInTimeFramePresentation() {
		return minPixelInTimeFramePresentation;
	}

	public double getPixelsInTimeFrame() {
		return pixelInTimeFrame;
	}

	// smallest number == 1, largest number == 100 was 2.01
	public void zoom(int number) {
		double adder = .02;
		double factor = 8.01;
		
		// taking formula using max and min from zoomPresentation() below
		if ( ! convertor.isTimeScaleMPEG()) {
			adder = minPixelInTimeFramePresentation;
			factor = maxPixelInTimeFramePresentation - minPixelInTimeFramePresentation;
		}
		pixelInTimeFrame = adder + factor * number / 100;
		convertor.setPixelInTimeFrame(pixelInTimeFrame);
	}

	public void zoomPresentation(int number) {
		
		if(number == 0 || number == 1) {
			pixelInTimeFrame = minPixelInTimeFramePresentation;
		} else if(number == 100) {
			pixelInTimeFrame = maxPixelInTimeFramePresentation;
		} else {
			pixelInTimeFrame = ((maxPixelInTimeFramePresentation - minPixelInTimeFramePresentation) * number / 100) + minPixelInTimeFramePresentation;	
		}
		
		convertor.setPixelInTimeFrame(pixelInTimeFrame);
		
	}
	
	public int getSliderPosition() {
		double d = 100 * (pixelInTimeFrame - 0.02) / 8.01;
		return (int) d;
	}

	public void setPixelInTimeFrame(int currentWidth, int desiredWidth) {
		double x = desiredWidth / currentWidth;
		pixelInTimeFrame = x * dPixelInTimeFrame; 
		convertor.setPixelInTimeFrame(pixelInTimeFrame);
	}

	public void zoomIn() {
		if (pixelInTimeFrame <= 16.6)
			pixelInTimeFrame += 0.02;
		convertor.setPixelInTimeFrame(pixelInTimeFrame);
	}

	public void zoomOut() {
		if (pixelInTimeFrame >= 0.02)
			pixelInTimeFrame -= 0.02;
		convertor.setPixelInTimeFrame(pixelInTimeFrame);
	}

	public CoordinateTimeConverter getCoordinateTimeConvertor() {
		return convertor;
	}
}
