package edu.bu.signstream.grepresentation.view.mediaControl;

import javax.swing.JTextField;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class BaseListener {
	
	MediaToolBar bar;

	BaseListener(MediaToolBar bar) {
		this.bar = bar;
	}
	
	SignStreamSegmentPanel getSignStreamSegmentPanel() {
		SignStreamSegmentPanel panel = bar.getSignStreamsegmentPanel();

		if (panel == null)
			return panel;

		if (panel.getMultipleMovieController().getMovies().isEmpty()) {
			// no video files are loaded
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.SELECT_VALID_VIDEO_FILE);
			return null;
		}
		
		MediaToolbarVideoController.stopPlayingVideo(panel);		
		return panel;
	}
	
	void movePanelToTime(SignStreamSegmentPanel panel, Event event, int time, JTextField field) {
		if(field != null) {
			field.setText(""+time);
		}
		panel.getMultipleMovieController().goToPacketTimeStamp(time);
		panel.getSlider().setSliderPositionTime(time);
		panel.setVisible(event);
		panel.repaint();
	}
}
