package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GoFirstFrameUtteranceListener extends BaseListener implements
		ActionListener {

	public GoFirstFrameUtteranceListener(MediaToolBar bar) {
		super(bar);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		SignStreamSegmentPanel panel = getSignStreamSegmentPanel();
		if (panel == null) {
			return;
		}
		
		EventsEntity selectedEntity = bar.getSelectedEventsEntity();		
		Field parentField = bar.getCurrentParentField();
		Event utterance = null;
		
		if (selectedEntity != null) {
			PresentationEventsEntity parentEntity = selectedEntity.getParentEntity();
			if (parentEntity != null) {
				utterance = parentEntity.getEvent();
			}
		}
		else if (parentField != null) {
			// slider coord
			int sliderPosition = bar.getSignStreamsegmentPanel().getSlider().getSliderPosition();
			PresentationEventsEntity parentEntity = (PresentationEventsEntity) parentField.getEventAt(sliderPosition);
			
			if (parentEntity != null) {
				utterance = parentEntity.getEvent();
			}
		}

		if (utterance != null) {
			int time = MediaToolbarUtilController.getUtteranceStartTime(panel, utterance);
			movePanelToTime(panel, utterance, time, null);
		} 
	}
}
