package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GoLastFrameUtteranceListener extends BaseListener implements ActionListener {

	public GoLastFrameUtteranceListener(MediaToolBar bar) {
		super(bar);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		SignStreamSegmentPanel panel = getSignStreamSegmentPanel();
		if (panel == null) {
			return;
		}
		
		EventsEntity selectedEntity = bar.getSelectedEventsEntity();			
		Field parentField = bar.getCurrentParentField();
		Event utterance = null;
		
		if (selectedEntity != null) {
			PresentationEventsEntity parentEntity = selectedEntity.getParentEntity();
			if (parentEntity != null) {
				utterance = parentEntity.getEvent();
			}
		}
		else if (parentField != null) {
			int sliderPosition = bar.getSignStreamsegmentPanel().getSlider().getSliderPosition();
			PresentationEventsEntity parentEntity = (PresentationEventsEntity) parentField.getEventAt(sliderPosition);
			
			if (parentEntity != null) {
				utterance = parentEntity.getEvent();
			}
		}
		
		if (utterance != null) {
			int time = MediaToolbarUtilController.getUtteranceEndTime(panel, utterance);
			movePanelToTime(panel, utterance, time, null);
		}
	}
	
	public void adjustMovieTime(SignStreamSegmentPanel panel) {
		if (panel != null && panel.getMultipleMovieController() != null) {
			int time = panel.getMultipleMovieController().getCurrentTime();

			if (time < 0)
				time = 0;

			int duration = panel.getMultipleMovieController().getMovieDuration();
			if (duration > 0 && time >= duration)
				return;
			panel.getMultipleMovieController().skipNumberOfFrames(1);
		}
	}
}
