package edu.bu.signstream.grepresentation.view.mediaControl;

import java.util.ArrayList;

import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.video.VideoControlPanel;

public class MediaToolbarVideoController {

	public static void stopPlayingVideo(SignStreamSegmentPanel segmentPanel) {

		if (segmentPanel.getMultipleMovieController().isPlaying()) {
			segmentPanel.getMultipleMovieController()
					.stopPalayingVideoUpdateVideoControlPanel();
		}
	}

	public static void playUtterance(SignStreamSegmentPanel panel, Event event) {
		
		int sTime = MediaToolbarUtilController.getUtteranceStartTime(panel, event);
		int eTime = MediaToolbarUtilController.getUtteranceEndTime(panel, event);

		if (event != null) {

			panel.getSlider().setSliderPositionTime(sTime);
			panel.repaint();

			ArrayList<VideoControlPanel> videoPanels = SS3Singleton
					.getVideoControlManager().getVideoControlPanels();

			for (VideoControlPanel videoPanel : videoPanels) {
				videoPanel.setStartVideoControls();
			}

			panel.getMultipleMovieController().playSegment(sTime, eTime,
					panel);
		} else {

			ArrayList<VideoControlPanel> videoPanels = SS3Singleton
					.getVideoControlManager().getVideoControlPanels();
			
			for (VideoControlPanel videoPanel : videoPanels) {
				videoPanel.setStartVideoControls();
			}

			panel.getSlider().setSliderPositionTime(1);
			panel.repaint();
			
			panel.getMultipleMovieController().playSegment(0,
					panel.getMultipleMovieController().getMovieDuration(),
					panel);
		}
	}
	
	public static void playVideoVisibleOnScreen(SignStreamSegmentPanel panel) {
		
		int sTime = SegmentGraphReprUtil.utteranceViewVisibleMovieOnset;
		int eTime = SegmentGraphReprUtil.utteranceViewVisibleMovieOffset;
		
		if (sTime > 0 && eTime > 0) {
			panel.getSlider().setSliderPositionTime(sTime);
			panel.repaint();

			ArrayList<VideoControlPanel> videoPanels = SS3Singleton
					.getVideoControlManager().getVideoControlPanels();

			for (VideoControlPanel videoPanel : videoPanels) {
				videoPanel.setStartVideoControls();
			}

			panel.getMultipleMovieController().playSegment(sTime, eTime,
					panel);
		} else {

			ArrayList<VideoControlPanel> videoPanels = SS3Singleton
					.getVideoControlManager().getVideoControlPanels();
			
			for (VideoControlPanel videoPanel : videoPanels) {
				videoPanel.setStartVideoControls();
			}

			panel.getSlider().setSliderPositionTime(1);
			panel.repaint();
			
			panel.getMultipleMovieController().playSegment(0,
					panel.getMultipleMovieController().getMovieDuration(),
					panel);
		}
	}
}