package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.video.VideoControlPanel;

public class PlayUtteranceListener implements ActionListener {
		
	private MediaToolBar bar;
	
	public PlayUtteranceListener(MediaToolBar bar) {
		this.bar = bar;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		
		SignStreamSegmentPanel panel = bar.getSignStreamsegmentPanel();
						
		if(panel != null) {
		
			MediaToolbarVideoController.stopPlayingVideo(panel);
			
			Event utterance = null;
			
			EventsEntity selectedEntity = bar.getSelectedEventsEntity();	
			Field parentField = bar.getCurrentParentField();
			if (parentField == null || !parentField.getSignStreamSegmentPanel().isUtteranceLoaded()) {
				ArrayList<VideoControlPanel> videoPanels = SS3Singleton
						.getVideoControlManager().getVideoControlPanels();
				
				for (VideoControlPanel videoPanel : videoPanels) {
					videoPanel.setStartVideoControls();
				}

				panel.getSlider().setSliderPositionTime(1);
				panel.repaint();
				
				panel.getMultipleMovieController().playSegment(0,
						panel.getMultipleMovieController().getMovieDuration(),
						panel);
			}
			else {
				if (selectedEntity != null) {
					PresentationEventsEntity parentEntity = selectedEntity.getParentEntity();
					if (parentEntity != null) {
						utterance = parentEntity.getEvent();
					}
				}
				else if (parentField != null) {
					// slider coord
					int sliderPosition = bar.getSignStreamsegmentPanel().getSlider().getSliderPosition();
					PresentationEventsEntity parentEntity = (PresentationEventsEntity) parentField.getEventAt(sliderPosition);
					
					if (parentEntity != null) {
						utterance = parentEntity.getEvent();
					}
				}
				
				if(utterance != null) {
				
					MediaToolbarVideoController.playUtterance(panel, utterance);
				
				} 
			}
			
			// allows the left/right arrow keys to move the video to work again
			panel.requestFocus();
		}
	}
}
