package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public abstract class StartFrameListener extends BaseListener implements ActionListener{
	
	public StartFrameListener(MediaToolBar bar) {
		super(bar);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		SignStreamSegmentPanel panel = getSignStreamSegmentPanel();
		Field field = bar.getSelectedField();
		Event event = bar.getSelectedEvent();

		if (panel == null || event == null)
			return;

		int time = event.getStartTimeInfo().getMovieTime();
		int newTime = getNewTime(panel, event);

		if (field instanceof PresentationField
				|| event instanceof PresentationEventsEntity) {
			EventsEntity entity = bar.getSelectedEventsEntity();
			if (MediaToolbarCommons.isUpdatablePresentationEvent(entity)) {
				MediaToolbarCommons.setPresentationEventStartTime(newTime, event,
						entity, field, panel, bar.getStartTimeTextField());
			}
		} else {
			MediaToolbarCommons.setSelectedEventStartTime(bar, newTime);		
			int updatedTime = event.getStartTimeInfo().getMovieTime();
			if (updatedTime != time) {
				movePanelToTime(panel, event, updatedTime, bar.getStartTimeTextField());
			}
		}
	}

	abstract int getNewTime(SignStreamSegmentPanel panel, Event event);	  
}
