package edu.bu.signstream.grepresentation.view.signbank;

import java.util.HashMap;

public class SignBankVariant {
	
	private String variantID = null;
	private String variantLabel = null;
	private String defaultOccurrenceID = null;
	private HashMap<String, SignBankOccurrence> occurrencesList = null;
	
	private SignBankMainGloss parentMainGloss = null;
	
	public SignBankVariant(SignBankMainGloss parentMainGloss, 
			String variantID, String varaintLabel, String defaultOccurrenceID) {
		this.parentMainGloss = parentMainGloss;
		this.variantID = variantID;
		this.variantLabel = varaintLabel;
		this.defaultOccurrenceID = defaultOccurrenceID;
		this.occurrencesList = new HashMap<String, SignBankOccurrence>();
	}
	
	public SignBankMainGloss getParentMainGloss() {
		return parentMainGloss;
	}
	
	public String getVariantLabel() {
		return variantLabel;
	}
	
	public String getVariantID() {
		return variantID;
	}
	
	public SignBankOccurrence getOccurrenceByID(String occurrenceID) {
		return occurrencesList.get(occurrenceID);
	}
	
	public SignBankOccurrence getDefaultOccurrence() {
		return occurrencesList.get(defaultOccurrenceID);
	}
	
	public String getDefaultOccurenceID() {
		return defaultOccurrenceID;
	}
	
	public void setDefaultOccurrenceID(String defaultOccurrenceID) {
		this.defaultOccurrenceID = defaultOccurrenceID;
	}

	/**
	 * Gets the list of SignBankOccurrence objects
	 * @return A HashMap from Occurrence ID -> Occurrence
	 */
	public HashMap<String, SignBankOccurrence> getOccurrencesList() {
		return occurrencesList;
	}
	
	@Override
	public String toString() {
		
		String ret = "SignBankVariant[";
		ret += "Variant ID=" + variantID;
		ret += ", Variant Label=" + variantLabel;
		ret += ", Default Occurrence ID=" + defaultOccurrenceID;
		for (SignBankOccurrence occurrence: occurrencesList.values()) {
			ret += "\n" + occurrence.toString();
		}
		ret += "\n/SignBankVariant]";
		
		return ret;
	}

}
