package edu.bu.signstream.ui.panels;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.util.ArrayList;

import javax.swing.JDialog;
import javax.swing.WindowConstants;

import edu.bu.signstream.common.util.vo.ss3.participants.SS3Participant;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class AnnotatorSelectionDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private AnnotatorSelectionPanel annotatorSelectionPanel = null;
	
	public AnnotatorSelectionDialog(ArrayList<SS3Participant> annotatorList, AnnotatorsDialog annotatorsDialog) {
		super(SS3Singleton.getSignStreamApplication(), true);	// sets modal to true
		
		if (annotatorsDialog.getAnnotatorsPanel().getParticipantsPaneScrolledView().isParticipant())
			setTitle("Select Participant");
		else
			setTitle("Select Annotator");
		
		annotatorSelectionPanel = new AnnotatorSelectionPanel(this, annotatorList, annotatorsDialog);
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		setPreferredSize(new Dimension(250, 200));	
		setResizable(false);
		
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(50, 50));
		contentPane.add(annotatorSelectionPanel, BorderLayout.CENTER);
		this.pack();		
	}
	
	public AnnotatorSelectionPanel getAnnotatorSelectionPanel() {
		return annotatorSelectionPanel;
	}

}
