package edu.bu.signstream.ui.panels.search;

import java.io.File;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Database;

public abstract class SearchExpression extends JPanel {
	
	private static final long serialVersionUID = 1L;
	
	protected JButton removeButton;
	protected SearchGroup parentGroup;
	protected SearchTreeNode searchTreeNode;
	protected SS3Database database;
	
	public SearchExpression(SS3Database database, SearchGroup parentGroup) {
		setDatabase(database);
		this.parentGroup = parentGroup;

		// removeButton is common to all sub-elements
		String minusFilePath = "icons/minus.gif";
		File file = new File(minusFilePath);
		if (file.exists()) {
			removeButton = new JButton(new ImageIcon(minusFilePath));
		} else {
			removeButton = new JButton("-");
			System.out.println("File '" + minusFilePath + "' was not found");
		}
		
	}
	
	public SearchGroup getParentGroup() {
		return parentGroup;
	}
	
	public SearchTreeNode getSearchTreeNode() {
		return searchTreeNode;
	}
	
	public SS3Database getDatabase() {
		return database;
	}
	
	public void setDatabase(SS3Database database) {
		this.database = database;
	}
	
	public abstract void createUI();

}
