package edu.bu.signstream.ui.panels.search;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;

public class SearchTreeNode extends DefaultMutableTreeNode {

	private static final long serialVersionUID = 1L;
	
	/*
	 * Inherited class variables:
	 * parent: TreeNode (cast to SearchTreeNode)
	 * children: Enumeration<TreeNode>
	 */
	
	private SearchExpressionData data;	
	private SearchOperator searchOperator;
	private boolean negateGroupFlag;
	
	public SearchTreeNode(SearchExpressionData data, SearchOperator searchOperator) {
		this.data = data;
		this.searchOperator = searchOperator;
		negateGroupFlag = false;
		
		this.children = new Vector();
	}
	
	public SearchExpressionData getData() {
		return data;
	}
	
	public void setData(SearchExpressionData data) {
		this.data = data;
	}
	
	public SearchOperator getSearchOperator() {
		return searchOperator;
	}
	
	public void setSearchOperator(SearchOperator searchOperator) {
		this.searchOperator = searchOperator;
	}
	
	public boolean isNegateGroup() {
		return negateGroupFlag;
	}
	
	public void setNegateGroupFlag(boolean negateGroupFlag) {
		this.negateGroupFlag = negateGroupFlag;
	}
	
	public boolean isRuleNode() {
		return children.size() == 0 && data != null;
	}
	
	public boolean isGroupNode() {
		return children.size() != 0 && data == null;
	}
	
	public ArrayList<SearchTreeNode> getChildrenAsList() {
		ArrayList<SearchTreeNode> list = new ArrayList<SearchTreeNode>();
		
		Enumeration iter = children();
		while (iter.hasMoreElements()) {
			list.add((SearchTreeNode) iter.nextElement());
		}
		
		return list;
	}

	/**
	 * Calls DefaultMutableTreeNode.add(MutableTreeNode newChild)
	 * and then sets newChild.parent equal to this SearchTreeNode
	 * @param newChild child to add to this SearchTreeNode
	 */
	@Override
	public void add(MutableTreeNode newChild) {
		super.add(newChild);
		
		newChild.setParent(this);
	}
	
	@Override
	public String toString() {
		return null;		
	}

}
