package edu.bu.signstream.ui.video;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class MovieActionDelegateSimulator extends MovieActionDelegate {

	private MultipleMovieControllerSimulator controller = null;

	public MovieActionDelegateSimulator(MultipleMovieControllerSimulator controller) {
		super(controller);
		this.controller = controller;
	}

	@Override
	public long playNextFrame() {
		long currentPacketTimeStamp = controller.getCurrentTime();
		long packetDuration = controller.getPacketDuration();
		long  newCurrentPacketTimeStamp = currentPacketTimeStamp + packetDuration;
		
		controller.setCurrentPacketTimeStamp(newCurrentPacketTimeStamp);

		return newCurrentPacketTimeStamp;
	}

	@Override
	public void goToPacketTimeStamp(long goToPacketTime) {
		controller.setCurrentPacketTimeStamp(goToPacketTime);
	}

	@Override
	public Integer play(long startMovieTime, long endMovieTime,
			SignStreamSegmentPanel segmentPanel) throws Exception {

		long packetTimeStamp = startMovieTime;
		int counter = 0;


		while (controller.isPlaying() && (packetTimeStamp < endMovieTime || endMovieTime == 0)) {
			counter ++;
			packetTimeStamp = packetTimeStamp + 10001;
			try {
				Thread.sleep(36);
			} catch (InterruptedException e) {
				return new Integer(0);
			}
			
			if (counter >= 3) {
				SS3Singleton.getVideoControlManager().getSlider()
						.setSliderPositionTime((int) packetTimeStamp);
				segmentPanel.repaint();
				counter = 0;
			}
		}
		
		if(counter > 0) {
			if(endMovieTime > 0) {
				packetTimeStamp = endMovieTime;
			}
			
			SS3Singleton.getVideoControlManager().getSlider().setSliderPositionTime((int) packetTimeStamp);
			segmentPanel.repaint();
		}
		
		return new Integer(1);
	}
	
	@Override
	public void executeDragging() {
//		int dragToTime = controller.getDragToTime(); 
//		
//		if (dragToTime == -1)
//			return;
//		
//		long currentPacketTimeStamp = controller.getCurrentTime();
//		long newCurrentPacketTimeStamp = currentPacketTimeStamp;
//		long packetDuration = controller.getPacketDuration();
//
//		long dFrame = -1;
//
//		if (currentPacketTimeStamp == dragToTime) {
//			dFrame = 0;
//		} else if (currentPacketTimeStamp < dragToTime) {
//			dFrame = (dragToTime - currentPacketTimeStamp) / packetDuration;
//		}
//
//		int time = dragToTime;
//		dragToTime = -1;
//		controller.setDragToTime(dragToTime);
//		
//		ArrayList<XugglerMovie> movies = controller.getMovies();
//
//		for (XugglerMovie movie : movies) {
//
//			if (dFrame == -1 || dFrame > 20) {
//				movie.getContainer().seekKeyFrame(movie.getVideoStreamId(), -1,
//						0);
//				movie.getContainer().seekKeyFrame(movie.getVideoStreamId(),
//						time - packetDuration, IContainer.SEEK_FLAG_BACKWARDS);
//			}
//
//			boolean toScroll = true;
//
//			long cPacketTimeStamp = currentPacketTimeStamp;
//
//			while (toScroll) {
//				// scroll frame by frame
//				boolean b = false;
//				while (!b) {
//					IPacket packet = IPacket.make();
//					int readPacket = 0;
//
//					try {
//						readPacket = movie.getContainer()
//								.readNextPacket(packet);
//						long packetTimeStamp = packet.getTimeStamp();
//
//						if (packetTimeStamp < 0) {
//							cPacketTimeStamp = cPacketTimeStamp
//									+ packetDuration;
//						} else {
//							cPacketTimeStamp = packetTimeStamp;
//						}
//
//					} catch (Exception ex1) {
//						;
//					}
//
//					if (readPacket < 0)
//						return;
//
//					if (packet.getStreamIndex() == movie.getVideoStreamId()) {
//						b = true;
//
//						IVideoPicture picture = IVideoPicture.make(movie
//								.getVideoCoder().getPixelType(), movie
//								.getVideoCoder().getWidth(), movie
//								.getVideoCoder().getHeight());
//
//						int offset = 0;
//						while (offset < packet.getSize()) {
//
//							int bytesDecoded = movie.getVideoCoder()
//									.decodeVideo(picture, packet, offset);
//							if (bytesDecoded < 0)
//								throw new RuntimeException(
//										"got error decoding video in: "
//												+ movie.getFilename());
//							offset += bytesDecoded;
//
//							if (picture.isComplete()) {
//								IVideoPicture newPic = picture;
//
//								if (movie.getResampler() != null) {
//
//									newPic = IVideoPicture.make(movie
//											.getResampler()
//											.getOutputPixelFormat(), picture
//											.getWidth(), picture.getHeight());
//									if (movie.getResampler().resample(newPic,
//											picture) < 0)
//										throw new RuntimeException(
//												"could not resample video from: "
//														+ movie.getFilename());
//								}
//
//								if (cPacketTimeStamp >= time
//										|| controller.getMovieDuration() <= time) {
//
//									if (newPic.getPixelType() != IPixelFormat.Type.BGR24)
//										throw new RuntimeException(
//												"could not decode video"
//														+ " as BGR 24 bit data in: "
//														+ movie.getFilename());
//
//									// convert the BGR24 to an Java buffered
//									// image
//									BufferedImage image = new BufferedImage(
//											picture.getWidth(),
//											picture.getHeight(),
//											BufferedImage.TYPE_3BYTE_BGR);
//									IConverter converter = ConverterFactory
//											.createConverter(image,
//													IPixelFormat.Type.BGR24);
//									BufferedImage javaImage = converter
//											.toImage(newPic);
//									movie.loadNextFrameImage(javaImage);
//									movie.updateJavaWindow(true);
//									image = null;
//									toScroll = false;
//									newCurrentPacketTimeStamp = cPacketTimeStamp;
//									
//									converter.delete();
//								}
//							}
//						}
//						
//						picture.delete();
//						packet.delete();
//					} else {
//						// not a video stream, silently drop it.
//						do {
//						} while (false);
//					}
//				}
//			}
//
//			if (movie.equals(movies.get(movies.size() - 1))) {
//				controller.setCurrentPacketTimeStamp(newCurrentPacketTimeStamp);
//			}
//
//			executeDragging();
//		}
	}
}

