package edu.bu.signstream.ui.video;

import java.util.ArrayList;
import edu.bu.signstream.grepresentation.view.main.Slider;
import edu.bu.signstream.grepresentation.view.main.Zoomer;

public class VideoControlManager {

	private ArrayList<VideoControlPanel> controlPanels = new ArrayList<VideoControlPanel>();	
	private MultipleMovieController movieController;
	
	private Zoomer zoomer = new Zoomer();	
	private Slider slider = new Slider();
	
	public VideoControlManager(MultipleMovieController movieController) {
		this.movieController = movieController;
	}
	
	public VideoControlPanel createVideoControlPanel() {
		VideoControlPanel panel = new VideoControlPanel(this);
		controlPanels.add(panel);
		
		return panel;
	}
	
	public VideoControlPanel createVideoControlPanel(boolean menuPanel) {
		VideoControlPanel panel = new VideoControlPanel(this, menuPanel);
		controlPanels.add(panel);
		return panel;
	}
	
	public void moveSliderToEndFrame() {
		for(VideoControlPanel controlPanel : controlPanels) {
			controlPanel.moveSliderToEndFrame();
		}
	}
	
	public void moveSliderTo(int x) {
		for(VideoControlPanel controlPanel : controlPanels) {
			controlPanel.moveSliderTo(x);
		}
	}
		
	public void goToBeginning() {
		movieController.getMovieActionDelegate().goToPacketTimeStamp(1);
	}
	
	public void goToEnd() {
		movieController.goToLastFrame();
	}
	
	public ArrayList<VideoControlPanel> getVideoControlPanels() {
		return controlPanels;
	}
	
	public MultipleMovieController getMultipleMovieController() {
		return movieController;
	}
	
	public void removeVBideoControlPanel(VideoControlPanel panel) {
		controlPanels.remove(panel);
	}

//	public void play() {
//		movieController.play(controlPanels);			
//	} 
	
	public long frameForward() {
		return movieController.frameForward(movieController.getCurrentTime());
	}
	
	public long frameBack() {			
		return movieController.frameBackward(movieController.getCurrentTime());

	}
	
	public Zoomer getZoomer() {
		return zoomer;	
	}
	
	public Slider getSlider() { 
		return slider;
	}
}
