package edu.bu.signstream.ui.video.actions;

import java.util.ArrayList;

import javax.swing.SwingWorker;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.video.MultipleMovieController;
import edu.bu.signstream.ui.video.VideoControlPanel;
import edu.bu.signstream.ui.video.XugglerMovie;

public class MoviePlayer extends SwingWorker<Integer, ArrayList<XugglerMovie>> {

	private MultipleMovieController controller = null;
	private ArrayList<VideoControlPanel> videoControlPanels = null;
	private SignStreamSegmentPanel segmentPanel = null;
	private int startMovieTime, endMovieTime;

	public MoviePlayer(final MultipleMovieController controller,
			ArrayList<VideoControlPanel> videoControlPanels,
			int startMovieTime, int endMovieTime,
			SignStreamSegmentPanel segmentPanel) {

		this.controller = controller;
		this.videoControlPanels = videoControlPanels;
		this.segmentPanel = segmentPanel;
		this.startMovieTime = startMovieTime;
		this.endMovieTime = endMovieTime;
	}

	@Override
	protected Integer doInBackground() throws Exception {
		return controller.getMovieActionDelegate().play(startMovieTime, endMovieTime, segmentPanel);
	}

	@Override
	protected void done() {
		
		if(controller.isPlaying()) {
			controller.stopPlayingMovie();
			for (VideoControlPanel videoControlPanel : videoControlPanels) {
				videoControlPanel.enableFunctions(true);
			}
		}

		if (isCancelled()) {
			System.out.println("Cancelled !");
			
			ArrayList<VideoControlPanel> videoPanels = SS3Singleton
					.getVideoControlManager().getVideoControlPanels();
			for (VideoControlPanel videoPanel : videoPanels) {
				videoPanel.setStartVideoControls();
			}
			
		} else {
			System.out.println("Done !");
			
			ArrayList<VideoControlPanel> videoPanels = SS3Singleton
					.getVideoControlManager().getVideoControlPanels();
			for (VideoControlPanel videoPanel : videoPanels) {
				videoPanel.setStopVideoControls();
			}
		}

		if (controller.getCurrentTime() < 0) {
			SS3Singleton.getVideoControlManager().moveSliderTo(
					MultipleMovieController.NUMBER_OF_SLIDER_TICKS);
		} else {
			segmentPanel.getSlider().setSliderPositionTime(
					controller.getCurrentTime());
		}
	}
}
